/* $Id$   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2013                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
/*  Define the basic components of the ObitTableRow structure       */
/*  This is intended to be included in a class structure definition   */
/**
 * \file ObitTableIDI_UV_DATARowDef.h
 * ObitTableIDI_UV_DATARow structure members for derived classes.
 */
#include "ObitTableRowDef.h"  /* Parent class definitions */
/** [OPTIONAL] U component of baseline. Unspecified projection */
ofloat  uu;
/** [OPTIONAL] V component of baseline. Unspecified projection */
ofloat  vv;
/** [OPTIONAL] W component of baseline. Unspecified projection */
ofloat  ww;
/** [OPTIONAL] U component of baseline. Sine projection */
ofloat  uusin;
/** [OPTIONAL] V component of baseline. Sine projection */
ofloat  vvsin;
/** [OPTIONAL] W component of baseline. Sine projection */
ofloat  wwsin;
/** [OPTIONAL] U component of baseline. NCP projection */
ofloat  uuncp;
/** [OPTIONAL] V component of baseline. NCP projection */
ofloat  vvncp;
/** [OPTIONAL] W component of baseline. NCP projection */
ofloat  wwncp;
/** Julian Date */
odouble  date;
/** The center time. */
odouble  Time;
/** Interferometer baseline as ant 1*256+ant1 (1-rel). */
oint  Baseline;
/** [OPTIONAL] Array number (1-rel) */
oint  Array;
/** [OPTIONAL]  VLBA Filter number. */
oint  Filter;
/** [OPTIONAL] Source ID, index into SOURCE table. */
oint  Source;
/** [OPTIONAL] Hack for nonstandard VLBA usage Source ID, index into SOURCE table. */
oint  VLBASource;
/** [OPTIONAL] Frequency group ID. */
oint  FreqID;
/** [OPTIONAL] The integration time. */
ofloat  IntTim;
/** [OPTIONAL] VLBA Pulsar gate ID. */
oint  GateID;
/** Weight per IF/poln. */
ofloat*  Weight;
/** Visibility matrix */
ofloat*  Flux;
/** status 0=normal, 1=modified, -1=flagged */
olong  status;
