/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
%{
#include "Obit.h"
#include "ObitData.h"
#include "ObitTableCL.h"
%}
 
%inline %{
 
extern ObitTable* TableCL (ObitData *inData, long *tabVer,
 	                   long access,
 	                   char *tabName,
                           int numPol, int numIF, int numTerm,
                           ObitErr *err)
 {
   ObitIOAccess laccess;
   /* Cast structural keywords to correct type */
   oint lnumPol = (oint)numPol;
   oint lnumIF = (oint)numIF;
   oint lnumTerm = (oint)numTerm;
   olong ltabVer = (olong)*tabVer;
   ObitTable *outTable=NULL;
   laccess = OBIT_IO_ReadOnly;
   if (access==2) laccess = OBIT_IO_WriteOnly;
   else if (access==3) laccess = OBIT_IO_ReadWrite;
   outTable = (ObitTable*)newObitTableCLValue ((gchar*)tabName, inData, (olong*)&ltabVer,
   			   laccess, 
                           lnumPol, lnumIF, lnumTerm,
                           err);
   *tabVer = (long)ltabVer;
   return outTable;
   }
 
extern PyObject* TableCLGetHeadKeys (ObitTable *inTab) {
  PyObject *outDict=PyDict_New();
  ObitTableCL *lTab = (ObitTableCL*)inTab;
  PyDict_SetItemString(outDict, "numPol",  PyLong_FromLong((long)lTab->numPol));
  PyDict_SetItemString(outDict, "numIF",  PyLong_FromLong((long)lTab->numIF));
  PyDict_SetItemString(outDict, "numTerm",  PyLong_FromLong((long)lTab->numTerm));
  PyDict_SetItemString(outDict, "revision",  PyLong_FromLong((long)lTab->revision));
  PyDict_SetItemString(outDict, "numAnt",  PyLong_FromLong((long)lTab->numAnt));
  PyDict_SetItemString(outDict, "mGMod",  PyFloat_FromDouble((double)lTab->mGMod));

  return outDict;
} 

extern void TableCLSetHeadKeys (ObitTable *inTab, PyObject *inDict) {
  ObitTableCL *lTab = (ObitTableCL*)inTab;
  char *tstr;
  int lstr=MAXKEYCHARTABLECL;

  lTab->revision = (oint)PyLong_AsLong(PyDict_GetItemString(inDict, "revision"));
  lTab->numAnt = (oint)PyLong_AsLong(PyDict_GetItemString(inDict, "numAnt"));
  lTab->mGMod = (odouble)PyFloat_AsDouble(PyDict_GetItemString(inDict, "mGMod"));

  if ((lTab->myDesc->access==OBIT_IO_ReadWrite) || (lTab->myDesc->access==OBIT_IO_WriteOnly)) 
    lTab->myStatus = OBIT_Modified;
} 

%}
