/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableCQ.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableCQ.c
 * ObitTableCQ class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableCQ";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableCQRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableCQRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableCQClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableCQClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableCQRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableCQRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableCQInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableCQClear (gpointer in);

/** Private: update table specific info */
static void ObitTableCQUpdate (ObitTableCQ *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableCQDumpKey (ObitTableCQ *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableCQClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableCQRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableCQRow* newObitTableCQRow (ObitTableCQ *table)
{
  ObitTableCQRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableCQRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableCQRow));

  /* initialize values */
  out->name = g_strdup("TableCQ Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableCQRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->FFTSize = iRow + table->FFTSizeOff;
    out->numChan = iRow + table->numChanOff;
    out->SpecAvg = iRow + table->SpecAvgOff;
    out->EdgeFreq = dRow + table->EdgeFreqOff;
    out->ChanBW = dRow + table->ChanBWOff;
    out->TaperFn = cRow + table->TaperFnOff;
    out->OverSamp = iRow + table->OverSampOff;
    out->ZeroPad = iRow + table->ZeroPadOff;
    out->Filter = iRow + table->FilterOff;
    out->TimeAvg = fRow + table->TimeAvgOff;
    out->numBits = iRow + table->numBitsOff;
    out->FFTOverlap = iRow + table->FFTOverlapOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableCQRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableCQRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableCQRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableCQRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableCQ* newObitTableCQ (gchar* name)
{
  ObitTableCQ* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCQClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableCQ));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableCQInit((gpointer)out);

 return out;
} /* end newObitTableCQ */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableCQGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCQClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitCQGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numIF The number of IFs
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableCQ* newObitTableCQValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numIF,
		     ObitErr *err)
{
  ObitTableCQ* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS CQ";
  gchar *routine = "newObitTableCQValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCQClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS CQ");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableCQ */
      if (ObitTableCQIsA(testTab)) { /* it is an ObitTableCQ */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableCQConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS CQ");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableCQIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableCQConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numIF = MAX (0, numIF);
  out->revision = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 14 + out->numIF*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("FRQSEL ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SUBARRAY ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FFT_SIZE ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("NO_CHAN ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("SPEC_AVG ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("EDGE_FRQ ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("CHAN_BW ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("TAPER_FN ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    desc->dim[colNo][1] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("OVR_SAMP ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ZERO_PAD ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FILTER ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("TIME_AVG ");
    desc->FieldUnit[colNo] = g_strdup("SECONDS");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("NO_BITS ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  optional = FALSE;
  if ((numIF > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FFT_OVLP ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_oint;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numIF;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableCQDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableCQOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableCQClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableCQValue */

/**
 * Convert an ObitTable to an ObitTableCQ.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableCQ* ObitTableCQConvert (ObitTable* in)
{
  ObitTableCQ *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableCQ(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableCQConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableCQ* ObitTableCQCopy (ObitTableCQ *in, ObitTableCQ *out, ObitErr *err)
{
  gchar *routine = "ObitTableCQCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCQClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableCQ*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  out->numIF = in->numIF;
  /* Update class specific info */
  ObitTableCQUpdate (out, err);
    
  return out;
} /* end ObitTableCQCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableCQOpen (ObitTableCQ *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableCQOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableCQClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableCQUpdate (in, err);
   
   return retCode;
} /* end ObitTableCQOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iCQRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableCQReadRow  (ObitTableCQ *in, olong iCQRow, ObitTableCQRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableCQReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS CQ Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iCQRow */
  retCode = ObitTableRead ((ObitTable*)in, iCQRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->FrqSel = iRow[in->FrqSelOff];
  row->SubA = iRow[in->SubAOff];
  row->FFTSize = iRow + in->FFTSizeOff;
  row->numChan = iRow + in->numChanOff;
  row->SpecAvg = iRow + in->SpecAvgOff;
  row->EdgeFreq = dRow + in->EdgeFreqOff;
  row->ChanBW = dRow + in->ChanBWOff;
  row->TaperFn = cRow + in->TaperFnOff;
  row->OverSamp = iRow + in->OverSampOff;
  row->ZeroPad = iRow + in->ZeroPadOff;
  row->Filter = iRow + in->FilterOff;
  row->TimeAvg = fRow + in->TimeAvgOff;
  row->numBits = iRow + in->numBitsOff;
  row->FFTOverlap = iRow + in->FFTOverlapOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableCQReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableCQSetRow  (ObitTableCQ *in, ObitTableCQRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "CQ Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->FFTSize = iRow + in->FFTSizeOff;
  row->numChan = iRow + in->numChanOff;
  row->SpecAvg = iRow + in->SpecAvgOff;
  row->EdgeFreq = dRow + in->EdgeFreqOff;
  row->ChanBW = dRow + in->ChanBWOff;
  row->TaperFn = cRow + in->TaperFnOff;
  row->OverSamp = iRow + in->OverSampOff;
  row->ZeroPad = iRow + in->ZeroPadOff;
  row->Filter = iRow + in->FilterOff;
  row->TimeAvg = fRow + in->TimeAvgOff;
  row->numBits = iRow + in->numBitsOff;
  row->FFTOverlap = iRow + in->FFTOverlapOff;

} /*  end ObitTableCQSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableCQSetRow  
 * \param in       Table to read
 * \param iCQRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableCQWriteRow  (ObitTableCQ *in, olong iCQRow, ObitTableCQRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableCQWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS CQ Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  iRow[in->FrqSelOff] = row->FrqSel;
  iRow[in->SubAOff] = row->SubA;
  if (in->FFTSizeCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FFTSizeCol]; i++) 
      iRow[in->FFTSizeOff+i] = row->FFTSize[i];
  } 
  if (in->numChanCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->numChanCol]; i++) 
      iRow[in->numChanOff+i] = row->numChan[i];
  } 
  if (in->SpecAvgCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->SpecAvgCol]; i++) 
      iRow[in->SpecAvgOff+i] = row->SpecAvg[i];
  } 
  if (in->EdgeFreqCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->EdgeFreqCol]; i++) 
      dRow[in->EdgeFreqOff+i] = row->EdgeFreq[i];
  } 
  if (in->ChanBWCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->ChanBWCol]; i++) 
      dRow[in->ChanBWOff+i] = row->ChanBW[i];
  } 
  if (in->TaperFnCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->TaperFnCol]; i++) 
      cRow[in->TaperFnOff+i] = row->TaperFn[i];
  } 
  if (in->OverSampCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->OverSampCol]; i++) 
      iRow[in->OverSampOff+i] = row->OverSamp[i];
  } 
  if (in->ZeroPadCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->ZeroPadCol]; i++) 
      iRow[in->ZeroPadOff+i] = row->ZeroPad[i];
  } 
  if (in->FilterCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FilterCol]; i++) 
      iRow[in->FilterOff+i] = row->Filter[i];
  } 
  if (in->TimeAvgCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->TimeAvgCol]; i++) 
      fRow[in->TimeAvgOff+i] = row->TimeAvg[i];
  } 
  if (in->numBitsCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->numBitsCol]; i++) 
      iRow[in->numBitsOff+i] = row->numBits[i];
  } 
  if (in->FFTOverlapCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FFTOverlapCol]; i++) 
      iRow[in->FFTOverlapOff+i] = row->FFTOverlap[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iCQRow */
  retCode = ObitTableWrite ((ObitTable*)in, iCQRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableCQWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableCQClose (ObitTableCQ *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableCQClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableCQDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableCQClose */

/*---------------Private functions--------------------------*/
/*----------------  TableCQ Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableCQRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCQRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->FFTSize = NULL;
  in->numChan = NULL;
  in->SpecAvg = NULL;
  in->EdgeFreq = NULL;
  in->ChanBW = NULL;
  in->TaperFn = NULL;
  in->OverSamp = NULL;
  in->ZeroPad = NULL;
  in->Filter = NULL;
  in->TimeAvg = NULL;
  in->numBits = NULL;
  in->FFTOverlap = NULL;

} /* end ObitTableCQRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableCQRow* cast to an Obit*.
 */
void ObitTableCQRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCQRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableCQRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableCQRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableCQRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableCQRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableCQRowClassInfoDefFn (gpointer inClass)
{
  ObitTableCQRowClassInfo *theClass = (ObitTableCQRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableCQRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableCQRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableCQRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableCQRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableCQRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableCQRowInit;

} /* end ObitTableCQRowClassDefFn */

/*------------------  TableCQ  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableCQInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCQ *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableCQInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableCQ* cast to an Obit*.
 */
void ObitTableCQClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableCQ *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableCQClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableCQClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableCQClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableCQClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableCQClassInfoDefFn (gpointer inClass)
{
  ObitTableCQClassInfo *theClass = (ObitTableCQClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableCQClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableCQClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableCQGetClass;
  theClass->newObit       = (newObitFP)newObitTableCQ;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableCQCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableCQClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableCQInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableCQConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableCQOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableCQClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableCQReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableCQWriteRow;

} /* end ObitTableCQClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableCQUpdate (ObitTableCQ *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);
   /* numIF */
  if (!ObitInfoListGet(in->myDesc->info, "NO_IF", &type, dim, 
		       (gpointer)&in->numIF, err)) return;

  /* initialize column numbers/offsets */
  in->FrqSelOff = -1;
  in->FrqSelCol = -1;
  in->SubAOff = -1;
  in->SubACol = -1;
  in->FFTSizeOff = -1;
  in->FFTSizeCol = -1;
  in->numChanOff = -1;
  in->numChanCol = -1;
  in->SpecAvgOff = -1;
  in->SpecAvgCol = -1;
  in->EdgeFreqOff = -1;
  in->EdgeFreqCol = -1;
  in->ChanBWOff = -1;
  in->ChanBWCol = -1;
  in->TaperFnOff = -1;
  in->TaperFnCol = -1;
  in->OverSampOff = -1;
  in->OverSampCol = -1;
  in->ZeroPadOff = -1;
  in->ZeroPadCol = -1;
  in->FilterOff = -1;
  in->FilterCol = -1;
  in->TimeAvgOff = -1;
  in->TimeAvgCol = -1;
  in->numBitsOff = -1;
  in->numBitsCol = -1;
  in->FFTOverlapOff = -1;
  in->FFTOverlapCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "FRQSEL ", 7)) {
	 in->FrqSelOff = desc->offset[i];
 	 in->FrqSelCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SUBARRAY ", 9)) {
	 in->SubAOff = desc->offset[i];
 	 in->SubACol = i;
      }
      if (!strncmp (desc->FieldName[i], "FFT_SIZE ", 9)) {
	 in->FFTSizeOff = desc->offset[i];
 	 in->FFTSizeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "NO_CHAN ", 8)) {
	 in->numChanOff = desc->offset[i];
 	 in->numChanCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SPEC_AVG ", 9)) {
	 in->SpecAvgOff = desc->offset[i];
 	 in->SpecAvgCol = i;
      }
      if (!strncmp (desc->FieldName[i], "EDGE_FRQ ", 9)) {
	 in->EdgeFreqOff = desc->offset[i];
 	 in->EdgeFreqCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CHAN_BW ", 8)) {
	 in->ChanBWOff = desc->offset[i];
 	 in->ChanBWCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TAPER_FN ", 9)) {
	 in->TaperFnOff = desc->offset[i];
 	 in->TaperFnCol = i;
      }
      if (!strncmp (desc->FieldName[i], "OVR_SAMP ", 9)) {
	 in->OverSampOff = desc->offset[i];
 	 in->OverSampCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ZERO_PAD ", 9)) {
	 in->ZeroPadOff = desc->offset[i];
 	 in->ZeroPadCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FILTER ", 7)) {
	 in->FilterOff = desc->offset[i];
 	 in->FilterCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME_AVG ", 9)) {
	 in->TimeAvgOff = desc->offset[i];
 	 in->TimeAvgCol = i;
      }
      if (!strncmp (desc->FieldName[i], "NO_BITS ", 8)) {
	 in->numBitsOff = desc->offset[i];
 	 in->numBitsCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FFT_OVLP ", 9)) {
	 in->FFTOverlapOff = desc->offset[i];
 	 in->FFTOverlapCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->FrqSelOff > -1), err,
       "ObitTableCQUpdate: Could not find column FrqSel");
  Obit_return_if_fail((in->SubAOff > -1), err,
       "ObitTableCQUpdate: Could not find column SubA");
  Obit_return_if_fail((in->FFTSizeOff > -1), err,
       "ObitTableCQUpdate: Could not find column FFTSize");
  Obit_return_if_fail((in->numChanOff > -1), err,
       "ObitTableCQUpdate: Could not find column numChan");
  Obit_return_if_fail((in->SpecAvgOff > -1), err,
       "ObitTableCQUpdate: Could not find column SpecAvg");
  Obit_return_if_fail((in->EdgeFreqOff > -1), err,
       "ObitTableCQUpdate: Could not find column EdgeFreq");
  Obit_return_if_fail((in->ChanBWOff > -1), err,
       "ObitTableCQUpdate: Could not find column ChanBW");
  Obit_return_if_fail((in->TaperFnOff > -1), err,
       "ObitTableCQUpdate: Could not find column TaperFn");
  Obit_return_if_fail((in->OverSampOff > -1), err,
       "ObitTableCQUpdate: Could not find column OverSamp");
  Obit_return_if_fail((in->ZeroPadOff > -1), err,
       "ObitTableCQUpdate: Could not find column ZeroPad");
  Obit_return_if_fail((in->FilterOff > -1), err,
       "ObitTableCQUpdate: Could not find column Filter");
  Obit_return_if_fail((in->TimeAvgOff > -1), err,
       "ObitTableCQUpdate: Could not find column TimeAvg");
  Obit_return_if_fail((in->numBitsOff > -1), err,
       "ObitTableCQUpdate: Could not find column numBits");
} /* end ObitTableCQUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableCQDumpKey (ObitTableCQ *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
  /* numIF */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_IF", type, dim, 
		  (gpointer)&in->numIF);
   
} /* end ObitTableCQDumpKey */
