/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_ANTENNA.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_ANTENNA.c
 * ObitTableIDI_ANTENNA class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_ANTENNA";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_ANTENNARow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_ANTENNARowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_ANTENNAClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_ANTENNAClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_ANTENNARowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_ANTENNARowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_ANTENNAInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_ANTENNAClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_ANTENNAUpdate (ObitTableIDI_ANTENNA *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_ANTENNADumpKey (ObitTableIDI_ANTENNA *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_ANTENNAClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_ANTENNARowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_ANTENNARow* newObitTableIDI_ANTENNARow (ObitTableIDI_ANTENNA *table)
{
  ObitTableIDI_ANTENNARow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_ANTENNARowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_ANTENNARow));

  /* initialize values */
  out->name = g_strdup("TableIDI_ANTENNA Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_ANTENNARowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->AntName = cRow + table->AntNameOff;
    out->PolAngA = fRow + table->PolAngAOff;
    out->PolCalA = fRow + table->PolCalAOff;
    out->PolAngB = fRow + table->PolAngBOff;
    out->PolCalB = fRow + table->PolCalBOff;
    out->BeamFWHM = fRow + table->BeamFWHMOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_ANTENNARow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_ANTENNARowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_ANTENNARowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_ANTENNARowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_ANTENNA* newObitTableIDI_ANTENNA (gchar* name)
{
  ObitTableIDI_ANTENNA* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_ANTENNAClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_ANTENNA));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_ANTENNAInit((gpointer)out);

 return out;
} /* end newObitTableIDI_ANTENNA */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_ANTENNAGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_ANTENNAClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_ANTENNAGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param no_band Number of frequency bands
 * \param numPCal Number of polarization calibration constants
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_ANTENNA* newObitTableIDI_ANTENNAValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint no_band, oint numPCal,
		     ObitErr *err)
{
  ObitTableIDI_ANTENNA* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "ANTENNA";
  gchar *routine = "newObitTableIDI_ANTENNAValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_ANTENNAClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "ANTENNA");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_ANTENNA */
      if (ObitTableIDI_ANTENNAIsA(testTab)) { /* it is an ObitTableIDI_ANTENNA */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_ANTENNAConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "ANTENNA");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_ANTENNAIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_ANTENNAConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->no_band = MAX (0, no_band);
  out->numPCal = MAX (0, numPCal);
  out->tabrev = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->no_chan = 1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_ANTENNA );
  strncpy (out->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_ANTENNA );
  strncpy (out->polType, "        ", MAXKEYCHARTABLEIDI_ANTENNA );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 14 + out->no_band*0 + out->numPCal*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAY");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME_INTERVAL");
  desc->FieldUnit[colNo] = g_strdup("DAY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ANNAME  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("NO_LEVELS");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("POLTYA  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_string;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLAA   ");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((numPCal > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLCALA");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numPCal;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("POLTYB ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_string;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLAB  ");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((numPCal > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POLCALB");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numPCal;
    desc->dim[colNo][1] = no_band;
    colNo++;
  }
  optional = TRUE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("BEAMFWHM");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_ANTENNADumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_ANTENNAOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_ANTENNAClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_ANTENNAValue */

/**
 * Convert an ObitTable to an ObitTableIDI_ANTENNA.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_ANTENNA* ObitTableIDI_ANTENNAConvert (ObitTable* in)
{
  ObitTableIDI_ANTENNA *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_ANTENNA(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_ANTENNAConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_ANTENNA* ObitTableIDI_ANTENNACopy (ObitTableIDI_ANTENNA *in, ObitTableIDI_ANTENNA *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_ANTENNACopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_ANTENNAClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_ANTENNA*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->no_band = in->no_band;
  out->no_chan = in->no_chan;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_ANTENNA );
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEIDI_ANTENNA );
  out->numPCal = in->numPCal;
  strncpy (out->polType, in->polType, MAXKEYCHARTABLEIDI_ANTENNA );
  /* Update class specific info */
  ObitTableIDI_ANTENNAUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_ANTENNACopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_ANTENNAOpen (ObitTableIDI_ANTENNA *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_ANTENNAOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_ANTENNAClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_ANTENNAUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_ANTENNAOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_ANTENNARow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_ANTENNAReadRow  (ObitTableIDI_ANTENNA *in, olong iIDI_ANTENNARow, ObitTableIDI_ANTENNARow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_ANTENNAReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_ANTENNA Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_ANTENNARow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_ANTENNARow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->time = dRow[in->timeOff];
  row->time_interval = fRow[in->time_intervalOff];
  row->antenna_no = iRow[in->antenna_noOff];
  row->array = iRow[in->arrayOff];
  row->freqid = iRow[in->freqidOff];
  row->no_levels = iRow[in->no_levelsOff];
  row->polTypeA = cRow[in->polTypeAOff];
  row->polTypeB = cRow[in->polTypeBOff];
  row->AntName = cRow + in->AntNameOff;
  row->PolAngA = fRow + in->PolAngAOff;
  row->PolCalA = fRow + in->PolCalAOff;
  row->PolAngB = fRow + in->PolAngBOff;
  row->PolCalB = fRow + in->PolCalBOff;
  row->BeamFWHM = fRow + in->BeamFWHMOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_ANTENNAReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_ANTENNASetRow  (ObitTableIDI_ANTENNA *in, ObitTableIDI_ANTENNARow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_ANTENNA Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->AntName = cRow + in->AntNameOff;
  row->PolAngA = fRow + in->PolAngAOff;
  row->PolCalA = fRow + in->PolCalAOff;
  row->PolAngB = fRow + in->PolAngBOff;
  row->PolCalB = fRow + in->PolCalBOff;
  row->BeamFWHM = fRow + in->BeamFWHMOff;

} /*  end ObitTableIDI_ANTENNASetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_ANTENNASetRow  
 * \param in       Table to read
 * \param iIDI_ANTENNARow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_ANTENNAWriteRow  (ObitTableIDI_ANTENNA *in, olong iIDI_ANTENNARow, ObitTableIDI_ANTENNARow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_ANTENNAWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_ANTENNA Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->timeOff] = row->time;
  fRow[in->time_intervalOff] = row->time_interval;
  iRow[in->antenna_noOff] = row->antenna_no;
  iRow[in->arrayOff] = row->array;
  iRow[in->freqidOff] = row->freqid;
  iRow[in->no_levelsOff] = row->no_levels;
  cRow[in->polTypeAOff] = row->polTypeA;
  cRow[in->polTypeBOff] = row->polTypeB;
  if (in->AntNameCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->AntNameCol]; i++) 
      cRow[in->AntNameOff+i] = row->AntName[i];
  } 
  if (in->PolAngACol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolAngACol]; i++) 
      fRow[in->PolAngAOff+i] = row->PolAngA[i];
  } 
  if (in->PolCalACol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolCalACol]; i++) 
      fRow[in->PolCalAOff+i] = row->PolCalA[i];
  } 
  if (in->PolAngBCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolAngBCol]; i++) 
      fRow[in->PolAngBOff+i] = row->PolAngB[i];
  } 
  if (in->PolCalBCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PolCalBCol]; i++) 
      fRow[in->PolCalBOff+i] = row->PolCalB[i];
  } 
  if (in->BeamFWHMCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->BeamFWHMCol]; i++) 
      fRow[in->BeamFWHMOff+i] = row->BeamFWHM[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_ANTENNARow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_ANTENNARow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_ANTENNAWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_ANTENNAClose (ObitTableIDI_ANTENNA *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_ANTENNAClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_ANTENNADumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_ANTENNAClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_ANTENNA Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_ANTENNARowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_ANTENNARow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->AntName = NULL;
  in->PolAngA = NULL;
  in->PolCalA = NULL;
  in->PolAngB = NULL;
  in->PolCalB = NULL;
  in->BeamFWHM = NULL;

} /* end ObitTableIDI_ANTENNARowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_ANTENNARow* cast to an Obit*.
 */
void ObitTableIDI_ANTENNARowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_ANTENNARow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_ANTENNARowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_ANTENNARowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_ANTENNARowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_ANTENNARowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_ANTENNARowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_ANTENNARowClassInfo *theClass = (ObitTableIDI_ANTENNARowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_ANTENNARowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_ANTENNARowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_ANTENNARowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_ANTENNARow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_ANTENNARowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_ANTENNARowInit;

} /* end ObitTableIDI_ANTENNARowClassDefFn */

/*------------------  TableIDI_ANTENNA  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_ANTENNAInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_ANTENNA *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_ANTENNAInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_ANTENNA* cast to an Obit*.
 */
void ObitTableIDI_ANTENNAClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_ANTENNA *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_ANTENNAClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_ANTENNAClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_ANTENNAClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_ANTENNAClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_ANTENNAClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_ANTENNAClassInfo *theClass = (ObitTableIDI_ANTENNAClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_ANTENNAClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_ANTENNAClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_ANTENNAGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_ANTENNA;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_ANTENNACopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_ANTENNAClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_ANTENNAInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_ANTENNAConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_ANTENNAOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_ANTENNAClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_ANTENNAReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_ANTENNAWriteRow;

} /* end ObitTableIDI_ANTENNAClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_ANTENNAUpdate (ObitTableIDI_ANTENNA *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_ANTENNA); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);
   /* RefDate */
  strncpy (in->RefDate, "YYYY-MM-DD", MAXKEYCHARTABLEIDI_ANTENNA); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);
   /* numPCal */
  in->numPCal = 4; 
  ObitInfoListGetTest(in->myDesc->info, "NOPCAL", &type, dim, 
		       (gpointer)&in->numPCal);
   /* polType */
  strncpy (in->polType, "        ", MAXKEYCHARTABLEIDI_ANTENNA); 
  ObitInfoListGetTest(in->myDesc->info, "POLTYPE", &type, dim, 
		       (gpointer)&in->polType);

  /* initialize column numbers/offsets */
  in->timeOff = -1;
  in->timeCol = -1;
  in->time_intervalOff = -1;
  in->time_intervalCol = -1;
  in->AntNameOff = -1;
  in->AntNameCol = -1;
  in->antenna_noOff = -1;
  in->antenna_noCol = -1;
  in->arrayOff = -1;
  in->arrayCol = -1;
  in->freqidOff = -1;
  in->freqidCol = -1;
  in->no_levelsOff = -1;
  in->no_levelsCol = -1;
  in->polTypeAOff = -1;
  in->polTypeACol = -1;
  in->PolAngAOff = -1;
  in->PolAngACol = -1;
  in->PolCalAOff = -1;
  in->PolCalACol = -1;
  in->polTypeBOff = -1;
  in->polTypeBCol = -1;
  in->PolAngBOff = -1;
  in->PolAngBCol = -1;
  in->PolCalBOff = -1;
  in->PolCalBCol = -1;
  in->BeamFWHMOff = -1;
  in->BeamFWHMCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->timeOff = desc->offset[i];
 	 in->timeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME_INTERVAL", 13)) {
	 in->time_intervalOff = desc->offset[i];
 	 in->time_intervalCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANNAME  ", 8)) {
	 in->AntNameOff = desc->offset[i];
 	 in->AntNameCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antenna_noOff = desc->offset[i];
 	 in->antenna_noCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY", 5)) {
	 in->arrayOff = desc->offset[i];
 	 in->arrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID", 6)) {
	 in->freqidOff = desc->offset[i];
 	 in->freqidCol = i;
      }
      if (!strncmp (desc->FieldName[i], "NO_LEVELS", 9)) {
	 in->no_levelsOff = desc->offset[i];
 	 in->no_levelsCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLTYA  ", 8)) {
	 in->polTypeAOff = desc->offset[i];
 	 in->polTypeACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLAA   ", 8)) {
	 in->PolAngAOff = desc->offset[i];
 	 in->PolAngACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLCALA", 7)) {
	 in->PolCalAOff = desc->offset[i];
 	 in->PolCalACol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLTYB ", 7)) {
	 in->polTypeBOff = desc->offset[i];
 	 in->polTypeBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLAB  ", 7)) {
	 in->PolAngBOff = desc->offset[i];
 	 in->PolAngBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POLCALB", 7)) {
	 in->PolCalBOff = desc->offset[i];
 	 in->PolCalBCol = i;
      }
      if (!strncmp (desc->FieldName[i], "BEAMFWHM", 8)) {
	 in->BeamFWHMOff = desc->offset[i];
 	 in->BeamFWHMCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->timeOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column time");
  Obit_return_if_fail((in->time_intervalOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column time_interval");
  Obit_return_if_fail((in->AntNameOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column AntName");
  Obit_return_if_fail((in->antenna_noOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column antenna_no");
  Obit_return_if_fail((in->arrayOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column array");
  Obit_return_if_fail((in->freqidOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column freqid");
  Obit_return_if_fail((in->no_levelsOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column no_levels");
  Obit_return_if_fail((in->polTypeAOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column polTypeA");
  Obit_return_if_fail((in->PolAngAOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column PolAngA");
  Obit_return_if_fail((in->PolCalAOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column PolCalA");
  Obit_return_if_fail((in->polTypeBOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column polTypeB");
  Obit_return_if_fail((in->PolAngBOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column PolAngB");
  Obit_return_if_fail((in->PolCalBOff > -1), err,
       "ObitTableIDI_ANTENNAUpdate: Could not find column PolCalB");
} /* end ObitTableIDI_ANTENNAUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_ANTENNADumpKey (ObitTableIDI_ANTENNA *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_ANTENNA;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_ANTENNA;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
  /* numPCal */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NOPCAL", type, dim, 
		  (gpointer)&in->numPCal);
  /* polType */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_ANTENNA;
  ObitInfoListAlwaysPut(info, "POLTYPE", type, dim, 
		  (gpointer)&in->polType);
   
} /* end ObitTableIDI_ANTENNADumpKey */
