/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableIDI_SOURCE.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableIDI_SOURCE.c
 * ObitTableIDI_SOURCE class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableIDI_SOURCE";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableIDI_SOURCERow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_SOURCERowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableIDI_SOURCEClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableIDI_SOURCEClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableIDI_SOURCERowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableIDI_SOURCERowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableIDI_SOURCEInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableIDI_SOURCEClear (gpointer in);

/** Private: update table specific info */
static void ObitTableIDI_SOURCEUpdate (ObitTableIDI_SOURCE *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableIDI_SOURCEDumpKey (ObitTableIDI_SOURCE *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableIDI_SOURCEClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableIDI_SOURCERowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_SOURCERow* newObitTableIDI_SOURCERow (ObitTableIDI_SOURCE *table)
{
  ObitTableIDI_SOURCERow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_SOURCERowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_SOURCERow));

  /* initialize values */
  out->name = g_strdup("TableIDI_SOURCE Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableIDI_SOURCERowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->Source = cRow + table->SourceOff;
    out->CalCode = cRow + table->CalCodeOff;
    out->IFlux = fRow + table->IFluxOff;
    out->QFlux = fRow + table->QFluxOff;
    out->UFlux = fRow + table->UFluxOff;
    out->VFlux = fRow + table->VFluxOff;
    out->alpha = fRow + table->alphaOff;
    out->FreqOff = fRow + table->FreqOffOff;
    out->Equinox = cRow + table->EquinoxOff;
    out->VLBAEquinox = cRow + table->VLBAEquinoxOff;
    out->SysVel = dRow + table->SysVelOff;
    out->VelTyp = cRow + table->VelTypOff;
    out->VelDef = cRow + table->VelDefOff;
    out->RestFreq = dRow + table->RestFreqOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableIDI_SOURCERow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableIDI_SOURCERowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableIDI_SOURCERowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableIDI_SOURCERowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableIDI_SOURCE* newObitTableIDI_SOURCE (gchar* name)
{
  ObitTableIDI_SOURCE* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_SOURCEClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableIDI_SOURCE));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableIDI_SOURCEInit((gpointer)out);

 return out;
} /* end newObitTableIDI_SOURCE */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableIDI_SOURCEGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_SOURCEClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitIDI_SOURCEGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param no_band [OPTIONAL] Number of frequency bands
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableIDI_SOURCE* newObitTableIDI_SOURCEValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint no_band,
		     ObitErr *err)
{
  ObitTableIDI_SOURCE* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "SOURCE";
  gchar *routine = "newObitTableIDI_SOURCEValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_SOURCEClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "SOURCE");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableIDI_SOURCE */
      if (ObitTableIDI_SOURCEIsA(testTab)) { /* it is an ObitTableIDI_SOURCE */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableIDI_SOURCEConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "SOURCE");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableIDI_SOURCEIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableIDI_SOURCEConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->no_band = MAX (0, no_band);
  out->tabrev = 1;
  out->no_chan = 1;
  out->no_stkd = 1;
  out->stk_1 = -1;
  out->ref_freq = 1.0;
  out->chan_bw = 1.0;
  out->ref_pixl = 1.0;
  strncpy (out->obscode, "    ", MAXKEYCHARTABLEIDI_SOURCE );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 26 + out->no_band*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("SOURCE_ID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ID_NO.");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((16 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("SOURCE  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 16;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("QUAL    ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((4 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("CALCODE ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 4;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("FREQID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("IFLUX   ");
    desc->FieldUnit[colNo] = g_strdup("JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("QFLUX   ");
    desc->FieldUnit[colNo] = g_strdup("JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("UFLUX   ");
    desc->FieldUnit[colNo] = g_strdup("JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("VFLUX   ");
    desc->FieldUnit[colNo] = g_strdup("JY");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ALPHA   ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("FREQOFF ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("RAEPO   ");
  desc->FieldUnit[colNo] = g_strdup("DEGREES");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DECEPO  ");
  desc->FieldUnit[colNo] = g_strdup("DEGREES");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = TRUE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("EQUINOX  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  optional = TRUE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("EPOCH   ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("RAAPP   ");
  desc->FieldUnit[colNo] = g_strdup("DEGREES");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DECAPP  ");
  desc->FieldUnit[colNo] = g_strdup("DEGREES");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("SYSVEL ");
    desc->FieldUnit[colNo] = g_strdup("M/SEC");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("VELTYP  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  optional = FALSE;
  if ((8 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("VELDEF  ");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_string;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 8;
    colNo++;
  }
  optional = FALSE;
  if ((no_band > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("RESTFREQ");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = no_band;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("PMRA   ");
  desc->FieldUnit[colNo] = g_strdup("DEG/DAY");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("PMDEC  ");
  desc->FieldUnit[colNo] = g_strdup("DEG/DAY");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("PARALLAX");
  desc->FieldUnit[colNo] = g_strdup("ARCSEC");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("EPOCH");
  desc->FieldUnit[colNo] = g_strdup("YEAR");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableIDI_SOURCEDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableIDI_SOURCEOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableIDI_SOURCEClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableIDI_SOURCEValue */

/**
 * Convert an ObitTable to an ObitTableIDI_SOURCE.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableIDI_SOURCE* ObitTableIDI_SOURCEConvert (ObitTable* in)
{
  ObitTableIDI_SOURCE *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableIDI_SOURCE(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableIDI_SOURCEConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableIDI_SOURCE* ObitTableIDI_SOURCECopy (ObitTableIDI_SOURCE *in, ObitTableIDI_SOURCE *out, ObitErr *err)
{
  gchar *routine = "ObitTableIDI_SOURCECopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_SOURCEClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableIDI_SOURCE*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->tabrev = in->tabrev;
  out->no_band = in->no_band;
  out->no_chan = in->no_chan;
  out->no_stkd = in->no_stkd;
  out->stk_1 = in->stk_1;
  out->ref_freq = in->ref_freq;
  out->chan_bw = in->chan_bw;
  out->ref_pixl = in->ref_pixl;
  strncpy (out->obscode, in->obscode, MAXKEYCHARTABLEIDI_SOURCE );
  /* Update class specific info */
  ObitTableIDI_SOURCEUpdate (out, err);
    
  return out;
} /* end ObitTableIDI_SOURCECopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS (AIPS not allowed) 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_SOURCEOpen (ObitTableIDI_SOURCE *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableIDI_SOURCEOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableIDI_SOURCEClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableIDI_SOURCEUpdate (in, err);
   
   return retCode;
} /* end ObitTableIDI_SOURCEOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iIDI_SOURCERow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_SOURCEReadRow  (ObitTableIDI_SOURCE *in, olong iIDI_SOURCERow, ObitTableIDI_SOURCERow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_SOURCEReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_SOURCE Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iIDI_SOURCERow */
  retCode = ObitTableRead ((ObitTable*)in, iIDI_SOURCERow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->SourID = iRow[in->SourIDOff];
  row->VLBAID = iRow[in->VLBAIDOff];
  row->Qual = iRow[in->QualOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->RAMean = dRow[in->RAMeanOff];
  row->DecMean = dRow[in->DecMeanOff];
  row->RAApp = dRow[in->RAAppOff];
  row->DecApp = dRow[in->DecAppOff];
  row->PMRa = dRow[in->PMRaOff];
  row->PMDec = dRow[in->PMDecOff];
  row->parallax = fRow[in->parallaxOff];
  row->Epoch = dRow[in->EpochOff];
  row->Source = cRow + in->SourceOff;
  row->CalCode = cRow + in->CalCodeOff;
  row->IFlux = fRow + in->IFluxOff;
  row->QFlux = fRow + in->QFluxOff;
  row->UFlux = fRow + in->UFluxOff;
  row->VFlux = fRow + in->VFluxOff;
  row->alpha = fRow + in->alphaOff;
  row->FreqOff = fRow + in->FreqOffOff;
  row->Equinox = cRow + in->EquinoxOff;
  row->VLBAEquinox = cRow + in->VLBAEquinoxOff;
  row->SysVel = dRow + in->SysVelOff;
  row->VelTyp = cRow + in->VelTypOff;
  row->VelDef = cRow + in->VelDefOff;
  row->RestFreq = dRow + in->RestFreqOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableIDI_SOURCEReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableIDI_SOURCESetRow  (ObitTableIDI_SOURCE *in, ObitTableIDI_SOURCERow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_SOURCE Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->Source = cRow + in->SourceOff;
  row->CalCode = cRow + in->CalCodeOff;
  row->IFlux = fRow + in->IFluxOff;
  row->QFlux = fRow + in->QFluxOff;
  row->UFlux = fRow + in->UFluxOff;
  row->VFlux = fRow + in->VFluxOff;
  row->alpha = fRow + in->alphaOff;
  row->FreqOff = fRow + in->FreqOffOff;
  row->Equinox = cRow + in->EquinoxOff;
  row->VLBAEquinox = cRow + in->VLBAEquinoxOff;
  row->SysVel = dRow + in->SysVelOff;
  row->VelTyp = cRow + in->VelTypOff;
  row->VelDef = cRow + in->VelDefOff;
  row->RestFreq = dRow + in->RestFreqOff;

} /*  end ObitTableIDI_SOURCESetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableIDI_SOURCESetRow  
 * \param in       Table to read
 * \param iIDI_SOURCERow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableIDI_SOURCEWriteRow  (ObitTableIDI_SOURCE *in, olong iIDI_SOURCERow, ObitTableIDI_SOURCERow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableIDI_SOURCEWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "IDI_SOURCE Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->VLBAIDOff] = row->VLBAID;
  iRow[in->QualOff] = row->Qual;
  iRow[in->FreqIDOff] = row->FreqID;
  dRow[in->RAMeanOff] = row->RAMean;
  dRow[in->DecMeanOff] = row->DecMean;
  dRow[in->RAAppOff] = row->RAApp;
  dRow[in->DecAppOff] = row->DecApp;
  dRow[in->PMRaOff] = row->PMRa;
  dRow[in->PMDecOff] = row->PMDec;
  fRow[in->parallaxOff] = row->parallax;
  dRow[in->EpochOff] = row->Epoch;
  if (in->SourceCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->SourceCol]; i++) 
      cRow[in->SourceOff+i] = row->Source[i];
  } 
  if (in->CalCodeCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->CalCodeCol]; i++) 
      cRow[in->CalCodeOff+i] = row->CalCode[i];
  } 
  if (in->IFluxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->IFluxCol]; i++) 
      fRow[in->IFluxOff+i] = row->IFlux[i];
  } 
  if (in->QFluxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->QFluxCol]; i++) 
      fRow[in->QFluxOff+i] = row->QFlux[i];
  } 
  if (in->UFluxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->UFluxCol]; i++) 
      fRow[in->UFluxOff+i] = row->UFlux[i];
  } 
  if (in->VFluxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->VFluxCol]; i++) 
      fRow[in->VFluxOff+i] = row->VFlux[i];
  } 
  if (in->alphaCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->alphaCol]; i++) 
      fRow[in->alphaOff+i] = row->alpha[i];
  } 
  if (in->FreqOffCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->FreqOffCol]; i++) 
      fRow[in->FreqOffOff+i] = row->FreqOff[i];
  } 
  if (in->EquinoxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->EquinoxCol]; i++) 
      cRow[in->EquinoxOff+i] = row->Equinox[i];
  } 
  if (in->VLBAEquinoxCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->VLBAEquinoxCol]; i++) 
      cRow[in->VLBAEquinoxOff+i] = row->VLBAEquinox[i];
  } 
  if (in->SysVelCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->SysVelCol]; i++) 
      dRow[in->SysVelOff+i] = row->SysVel[i];
  } 
  if (in->VelTypCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->VelTypCol]; i++) 
      cRow[in->VelTypOff+i] = row->VelTyp[i];
  } 
  if (in->VelDefCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->VelDefCol]; i++) 
      cRow[in->VelDefOff+i] = row->VelDef[i];
  } 
  if (in->RestFreqCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->RestFreqCol]; i++) 
      dRow[in->RestFreqOff+i] = row->RestFreq[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iIDI_SOURCERow */
  retCode = ObitTableWrite ((ObitTable*)in, iIDI_SOURCERow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableIDI_SOURCEWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableIDI_SOURCEClose (ObitTableIDI_SOURCE *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableIDI_SOURCEClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableIDI_SOURCEDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableIDI_SOURCEClose */

/*---------------Private functions--------------------------*/
/*----------------  TableIDI_SOURCE Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_SOURCERowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_SOURCERow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->Source = NULL;
  in->CalCode = NULL;
  in->IFlux = NULL;
  in->QFlux = NULL;
  in->UFlux = NULL;
  in->VFlux = NULL;
  in->alpha = NULL;
  in->FreqOff = NULL;
  in->Equinox = NULL;
  in->VLBAEquinox = NULL;
  in->SysVel = NULL;
  in->VelTyp = NULL;
  in->VelDef = NULL;
  in->RestFreq = NULL;

} /* end ObitTableIDI_SOURCERowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_SOURCERow* cast to an Obit*.
 */
void ObitTableIDI_SOURCERowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_SOURCERow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_SOURCERowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_SOURCERowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableIDI_SOURCERowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_SOURCERowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_SOURCERowClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_SOURCERowClassInfo *theClass = (ObitTableIDI_SOURCERowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_SOURCERowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_SOURCERowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_SOURCERowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableIDI_SOURCERow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableIDI_SOURCERowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableIDI_SOURCERowInit;

} /* end ObitTableIDI_SOURCERowClassDefFn */

/*------------------  TableIDI_SOURCE  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableIDI_SOURCEInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_SOURCE *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableIDI_SOURCEInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableIDI_SOURCE* cast to an Obit*.
 */
void ObitTableIDI_SOURCEClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableIDI_SOURCE *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableIDI_SOURCEClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableIDI_SOURCEClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableIDI_SOURCEClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableIDI_SOURCEClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableIDI_SOURCEClassInfoDefFn (gpointer inClass)
{
  ObitTableIDI_SOURCEClassInfo *theClass = (ObitTableIDI_SOURCEClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableIDI_SOURCEClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableIDI_SOURCEClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableIDI_SOURCEGetClass;
  theClass->newObit       = (newObitFP)newObitTableIDI_SOURCE;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableIDI_SOURCECopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableIDI_SOURCEClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableIDI_SOURCEInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableIDI_SOURCEConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableIDI_SOURCEOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableIDI_SOURCEClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableIDI_SOURCEReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableIDI_SOURCEWriteRow;

} /* end ObitTableIDI_SOURCEClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_SOURCEUpdate (ObitTableIDI_SOURCE *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* tabrev */
  in->tabrev = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->tabrev);
   /* no_band */
  in->no_band = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->no_band);
   /* no_chan */
  in->no_chan = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_CHAN", &type, dim, 
		       (gpointer)&in->no_chan);
   /* no_stkd */
  in->no_stkd = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_STKD", &type, dim, 
		       (gpointer)&in->no_stkd);
   /* stk_1 */
  in->stk_1 = -1; 
  ObitInfoListGetTest(in->myDesc->info, "STK_1", &type, dim, 
		       (gpointer)&in->stk_1);
  in->ref_freq = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "REF_FREQ", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->ref_freq = InfoReal.dbl;
  if (type==OBIT_float)  in->ref_freq = InfoReal.flt;
  in->chan_bw = 1.0; 
  InfoReal.dbl = 1.0; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "CHAN_BW", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->chan_bw = InfoReal.dbl;
  if (type==OBIT_float)  in->chan_bw = InfoReal.flt;
   /* ref_pixl */
  in->ref_pixl = 1.0; 
  ObitInfoListGetTest(in->myDesc->info, "REF_PIXL", &type, dim, 
		       (gpointer)&in->ref_pixl);
   /* obscode */
  strncpy (in->obscode, "    ", MAXKEYCHARTABLEIDI_SOURCE); 
  ObitInfoListGetTest(in->myDesc->info, "OBSCODE", &type, dim, 
		       (gpointer)&in->obscode);

  /* initialize column numbers/offsets */
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->VLBAIDOff = -1;
  in->VLBAIDCol = -1;
  in->SourceOff = -1;
  in->SourceCol = -1;
  in->QualOff = -1;
  in->QualCol = -1;
  in->CalCodeOff = -1;
  in->CalCodeCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->IFluxOff = -1;
  in->IFluxCol = -1;
  in->QFluxOff = -1;
  in->QFluxCol = -1;
  in->UFluxOff = -1;
  in->UFluxCol = -1;
  in->VFluxOff = -1;
  in->VFluxCol = -1;
  in->alphaOff = -1;
  in->alphaCol = -1;
  in->FreqOffOff = -1;
  in->FreqOffCol = -1;
  in->RAMeanOff = -1;
  in->RAMeanCol = -1;
  in->DecMeanOff = -1;
  in->DecMeanCol = -1;
  in->EquinoxOff = -1;
  in->EquinoxCol = -1;
  in->VLBAEquinoxOff = -1;
  in->VLBAEquinoxCol = -1;
  in->RAAppOff = -1;
  in->RAAppCol = -1;
  in->DecAppOff = -1;
  in->DecAppCol = -1;
  in->SysVelOff = -1;
  in->SysVelCol = -1;
  in->VelTypOff = -1;
  in->VelTypCol = -1;
  in->VelDefOff = -1;
  in->VelDefCol = -1;
  in->RestFreqOff = -1;
  in->RestFreqCol = -1;
  in->PMRaOff = -1;
  in->PMRaCol = -1;
  in->PMDecOff = -1;
  in->PMDecCol = -1;
  in->parallaxOff = -1;
  in->parallaxCol = -1;
  in->EpochOff = -1;
  in->EpochCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "SOURCE_ID", 9)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ID_NO.", 6)) {
	 in->VLBAIDOff = desc->offset[i];
 	 in->VLBAIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE  ", 8)) {
	 in->SourceOff = desc->offset[i];
 	 in->SourceCol = i;
      }
      if (!strncmp (desc->FieldName[i], "QUAL    ", 8)) {
	 in->QualOff = desc->offset[i];
 	 in->QualCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CALCODE ", 8)) {
	 in->CalCodeOff = desc->offset[i];
 	 in->CalCodeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID  ", 8)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "IFLUX   ", 8)) {
	 in->IFluxOff = desc->offset[i];
 	 in->IFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "QFLUX   ", 8)) {
	 in->QFluxOff = desc->offset[i];
 	 in->QFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "UFLUX   ", 8)) {
	 in->UFluxOff = desc->offset[i];
 	 in->UFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "VFLUX   ", 8)) {
	 in->VFluxOff = desc->offset[i];
 	 in->VFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ALPHA   ", 8)) {
	 in->alphaOff = desc->offset[i];
 	 in->alphaCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQOFF ", 8)) {
	 in->FreqOffOff = desc->offset[i];
 	 in->FreqOffCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RAEPO   ", 8)) {
	 in->RAMeanOff = desc->offset[i];
 	 in->RAMeanCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DECEPO  ", 8)) {
	 in->DecMeanOff = desc->offset[i];
 	 in->DecMeanCol = i;
      }
      if (!strncmp (desc->FieldName[i], "EQUINOX  ", 9)) {
	 in->EquinoxOff = desc->offset[i];
 	 in->EquinoxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "EPOCH   ", 8)) {
	 in->VLBAEquinoxOff = desc->offset[i];
 	 in->VLBAEquinoxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RAAPP   ", 8)) {
	 in->RAAppOff = desc->offset[i];
 	 in->RAAppCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DECAPP  ", 8)) {
	 in->DecAppOff = desc->offset[i];
 	 in->DecAppCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SYSVEL ", 7)) {
	 in->SysVelOff = desc->offset[i];
 	 in->SysVelCol = i;
      }
      if (!strncmp (desc->FieldName[i], "VELTYP  ", 8)) {
	 in->VelTypOff = desc->offset[i];
 	 in->VelTypCol = i;
      }
      if (!strncmp (desc->FieldName[i], "VELDEF  ", 8)) {
	 in->VelDefOff = desc->offset[i];
 	 in->VelDefCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RESTFREQ", 8)) {
	 in->RestFreqOff = desc->offset[i];
 	 in->RestFreqCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PMRA   ", 7)) {
	 in->PMRaOff = desc->offset[i];
 	 in->PMRaCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PMDEC  ", 7)) {
	 in->PMDecOff = desc->offset[i];
 	 in->PMDecCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PARALLAX", 8)) {
	 in->parallaxOff = desc->offset[i];
 	 in->parallaxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "EPOCH", 5)) {
	 in->EpochOff = desc->offset[i];
 	 in->EpochCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->SourceOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column Source");
  Obit_return_if_fail((in->QualOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column Qual");
  Obit_return_if_fail((in->CalCodeOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column CalCode");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column FreqID");
  Obit_return_if_fail((in->IFluxOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column IFlux");
  Obit_return_if_fail((in->QFluxOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column QFlux");
  Obit_return_if_fail((in->UFluxOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column UFlux");
  Obit_return_if_fail((in->VFluxOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column VFlux");
  Obit_return_if_fail((in->alphaOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column alpha");
  Obit_return_if_fail((in->FreqOffOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column FreqOff");
  Obit_return_if_fail((in->RAMeanOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column RAMean");
  Obit_return_if_fail((in->DecMeanOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column DecMean");
  Obit_return_if_fail((in->RAAppOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column RAApp");
  Obit_return_if_fail((in->DecAppOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column DecApp");
  Obit_return_if_fail((in->SysVelOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column SysVel");
  Obit_return_if_fail((in->VelTypOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column VelTyp");
  Obit_return_if_fail((in->VelDefOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column VelDef");
  Obit_return_if_fail((in->RestFreqOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column RestFreq");
  Obit_return_if_fail((in->PMRaOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column PMRa");
  Obit_return_if_fail((in->PMDecOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column PMDec");
  Obit_return_if_fail((in->parallaxOff > -1), err,
       "ObitTableIDI_SOURCEUpdate: Could not find column parallax");
} /* end ObitTableIDI_SOURCEUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableIDI_SOURCEDumpKey (ObitTableIDI_SOURCE *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* tabrev */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->tabrev);
  /* no_band */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->no_band);
  /* no_chan */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_CHAN", type, dim, 
		  (gpointer)&in->no_chan);
  /* no_stkd */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_STKD", type, dim, 
		  (gpointer)&in->no_stkd);
  /* stk_1 */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "STK_1", type, dim, 
		  (gpointer)&in->stk_1);
  /* ref_freq */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_FREQ", type, dim, 
		  (gpointer)&in->ref_freq);
  /* chan_bw */
  type  = OBIT_double;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "CHAN_BW", type, dim, 
		  (gpointer)&in->chan_bw);
  /* ref_pixl */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "REF_PIXL", type, dim, 
		  (gpointer)&in->ref_pixl);
  /* obscode */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEIDI_SOURCE;
  ObitInfoListAlwaysPut(info, "OBSCODE", type, dim, 
		  (gpointer)&in->obscode);
   
} /* end ObitTableIDI_SOURCEDumpKey */
