/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTableMF.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTableMF.c
 * ObitTableMF class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTableMF";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTableMFRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableMFRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTableMFClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTableMFClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTableMFRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTableMFRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTableMFInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTableMFClear (gpointer in);

/** Private: update table specific info */
static void ObitTableMFUpdate (ObitTableMF *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTableMFDumpKey (ObitTableMF *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTableMFClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTableMFRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableMFRow* newObitTableMFRow (ObitTableMF *table)
{
  ObitTableMFRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableMFRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableMFRow));

  /* initialize values */
  out->name = g_strdup("TableMF Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTableMFRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTableMFRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTableMFRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTableMFRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTableMFRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTableMF* newObitTableMF (gchar* name)
{
  ObitTableMF* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMFClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTableMF));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTableMFInit((gpointer)out);

 return out;
} /* end newObitTableMF */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTableMFGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMFClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitMFGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTableMF* newObitTableMFValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		    
		     ObitErr *err)
{
  ObitTableMF* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS MF";
  gchar *routine = "newObitTableMFValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMFClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS MF");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTableMF */
      if (ObitTableMFIsA(testTab)) { /* it is an ObitTableMF */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTableMFConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS MF");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTableMFIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTableMFConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->depth1 = 1;
  out->depth2 = 1;
  out->depth3 = 1;
  out->depth4 = 1;
  out->depth5 = 1;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 39 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("PLANE ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("PEAK INT");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("I FLUX ");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DELTAX ");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("DELTAY ");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MAJOR AX");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MINOR AX");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("POSANGLE");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("Q FLUX  ");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("U FLUX ");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("V FLUX  ");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR PEAK");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR FLUX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR DLTX");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR DLTY");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR MAJA");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR MINA");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR PA ");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR QFLX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR UFLX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ERR VFLX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TYPE MOD");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D0 MAJOR");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D0 MINOR");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D0 POSANG");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D- MAJOR");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D- MINOR");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D- POSAN");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D+ MAJOR");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D+ MINOR");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("D+ POSAN");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("RES RMS ");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("RES PEAK");
  desc->FieldUnit[colNo] = g_strdup("JY/BEAM");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("RES FLUX");
  desc->FieldUnit[colNo] = g_strdup("JY");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("CENTER X");
  desc->FieldUnit[colNo] = g_strdup("PIXEL");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("CENTER Y");
  desc->FieldUnit[colNo] = g_strdup("PIXEL");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MAJ AXIS");
  desc->FieldUnit[colNo] = g_strdup("PIXEL");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("MIN AXIS");
  desc->FieldUnit[colNo] = g_strdup("PIXEL");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("PIXEL PA");
  desc->FieldUnit[colNo] = g_strdup("DEGREE");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTableMFDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTableMFOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTableMFClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTableMFValue */

/**
 * Convert an ObitTable to an ObitTableMF.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTableMF* ObitTableMFConvert (ObitTable* in)
{
  ObitTableMF *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTableMF(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTableMFConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTableMF* ObitTableMFCopy (ObitTableMF *in, ObitTableMF *out, ObitErr *err)
{
  gchar *routine = "ObitTableMFCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMFClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTableMF*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->depth1 = in->depth1;
  out->depth2 = in->depth2;
  out->depth3 = in->depth3;
  out->depth4 = in->depth4;
  out->depth5 = in->depth5;
  /* Update class specific info */
  ObitTableMFUpdate (out, err);
    
  return out;
} /* end ObitTableMFCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableMFOpen (ObitTableMF *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTableMFOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTableMFClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTableMFUpdate (in, err);
   
   return retCode;
} /* end ObitTableMFOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iMFRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableMFReadRow  (ObitTableMF *in, olong iMFRow, ObitTableMFRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableMFReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS MF Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iMFRow */
  retCode = ObitTableRead ((ObitTable*)in, iMFRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->plane = fRow[in->planeOff];
  row->Peak = fRow[in->PeakOff];
  row->IFlux = fRow[in->IFluxOff];
  row->DeltaX = fRow[in->DeltaXOff];
  row->DeltaY = fRow[in->DeltaYOff];
  row->MajorAx = fRow[in->MajorAxOff];
  row->MinorAx = fRow[in->MinorAxOff];
  row->PosAngle = fRow[in->PosAngleOff];
  row->QFlux = fRow[in->QFluxOff];
  row->UFlux = fRow[in->UFluxOff];
  row->VFlux = fRow[in->VFluxOff];
  row->errPeak = fRow[in->errPeakOff];
  row->errIFlux = fRow[in->errIFluxOff];
  row->errDeltaX = fRow[in->errDeltaXOff];
  row->errDeltaY = fRow[in->errDeltaYOff];
  row->errMajorAx = fRow[in->errMajorAxOff];
  row->errMinorAx = fRow[in->errMinorAxOff];
  row->errPosAngle = fRow[in->errPosAngleOff];
  row->errQFlux = fRow[in->errQFluxOff];
  row->errUFlux = fRow[in->errUFluxOff];
  row->errVFlux = fRow[in->errVFluxOff];
  row->TypeMod = fRow[in->TypeModOff];
  row->D0Major = fRow[in->D0MajorOff];
  row->D0Minor = fRow[in->D0MinorOff];
  row->D0PosAngle = fRow[in->D0PosAngleOff];
  row->DmMajor = fRow[in->DmMajorOff];
  row->DmMinor = fRow[in->DmMinorOff];
  row->DmPosAngle = fRow[in->DmPosAngleOff];
  row->DpMajor = fRow[in->DpMajorOff];
  row->DpMinor = fRow[in->DpMinorOff];
  row->DpPosAngle = fRow[in->DpPosAngleOff];
  row->ResRMS = fRow[in->ResRMSOff];
  row->ResPeak = fRow[in->ResPeakOff];
  row->ResFlux = fRow[in->ResFluxOff];
  row->PixelCenterX = fRow[in->PixelCenterXOff];
  row->PixelCenterY = fRow[in->PixelCenterYOff];
  row->PixelMajorAxis = fRow[in->PixelMajorAxisOff];
  row->PixelMinorAxis = fRow[in->PixelMinorAxisOff];
  row->PixelPosAngle = fRow[in->PixelPosAngleOff];
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTableMFReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTableMFSetRow  (ObitTableMF *in, ObitTableMFRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "MF Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */

} /*  end ObitTableMFSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTableMFSetRow  
 * \param in       Table to read
 * \param iMFRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTableMFWriteRow  (ObitTableMF *in, olong iMFRow, ObitTableMFRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTableMFWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS MF Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  fRow[in->planeOff] = row->plane;
  fRow[in->PeakOff] = row->Peak;
  fRow[in->IFluxOff] = row->IFlux;
  fRow[in->DeltaXOff] = row->DeltaX;
  fRow[in->DeltaYOff] = row->DeltaY;
  fRow[in->MajorAxOff] = row->MajorAx;
  fRow[in->MinorAxOff] = row->MinorAx;
  fRow[in->PosAngleOff] = row->PosAngle;
  fRow[in->QFluxOff] = row->QFlux;
  fRow[in->UFluxOff] = row->UFlux;
  fRow[in->VFluxOff] = row->VFlux;
  fRow[in->errPeakOff] = row->errPeak;
  fRow[in->errIFluxOff] = row->errIFlux;
  fRow[in->errDeltaXOff] = row->errDeltaX;
  fRow[in->errDeltaYOff] = row->errDeltaY;
  fRow[in->errMajorAxOff] = row->errMajorAx;
  fRow[in->errMinorAxOff] = row->errMinorAx;
  fRow[in->errPosAngleOff] = row->errPosAngle;
  fRow[in->errQFluxOff] = row->errQFlux;
  fRow[in->errUFluxOff] = row->errUFlux;
  fRow[in->errVFluxOff] = row->errVFlux;
  fRow[in->TypeModOff] = row->TypeMod;
  fRow[in->D0MajorOff] = row->D0Major;
  fRow[in->D0MinorOff] = row->D0Minor;
  fRow[in->D0PosAngleOff] = row->D0PosAngle;
  fRow[in->DmMajorOff] = row->DmMajor;
  fRow[in->DmMinorOff] = row->DmMinor;
  fRow[in->DmPosAngleOff] = row->DmPosAngle;
  fRow[in->DpMajorOff] = row->DpMajor;
  fRow[in->DpMinorOff] = row->DpMinor;
  fRow[in->DpPosAngleOff] = row->DpPosAngle;
  fRow[in->ResRMSOff] = row->ResRMS;
  fRow[in->ResPeakOff] = row->ResPeak;
  fRow[in->ResFluxOff] = row->ResFlux;
  fRow[in->PixelCenterXOff] = row->PixelCenterX;
  fRow[in->PixelCenterYOff] = row->PixelCenterY;
  fRow[in->PixelMajorAxisOff] = row->PixelMajorAxis;
  fRow[in->PixelMinorAxisOff] = row->PixelMinorAxis;
  fRow[in->PixelPosAngleOff] = row->PixelPosAngle;

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iMFRow */
  retCode = ObitTableWrite ((ObitTable*)in, iMFRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTableMFWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTableMFClose (ObitTableMF *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTableMFClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTableMFDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTableMFClose */

/*---------------Private functions--------------------------*/
/*----------------  TableMF Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableMFRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMFRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */

} /* end ObitTableMFRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableMFRow* cast to an Obit*.
 */
void ObitTableMFRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMFRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableMFRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableMFRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTableMFRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableMFRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableMFRowClassInfoDefFn (gpointer inClass)
{
  ObitTableMFRowClassInfo *theClass = (ObitTableMFRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableMFRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableMFRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableMFRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTableMFRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTableMFRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTableMFRowInit;

} /* end ObitTableMFRowClassDefFn */

/*------------------  TableMF  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTableMFInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMF *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTableMFInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTableMF* cast to an Obit*.
 */
void ObitTableMFClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTableMF *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTableMFClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTableMFClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTableMFClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTableMFClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTableMFClassInfoDefFn (gpointer inClass)
{
  ObitTableMFClassInfo *theClass = (ObitTableMFClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTableMFClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTableMFClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTableMFGetClass;
  theClass->newObit       = (newObitFP)newObitTableMF;
  theClass->ObitCopy      = (ObitCopyFP)ObitTableMFCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTableMFClear;
  theClass->ObitInit      = (ObitInitFP)ObitTableMFInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTableMFConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTableMFOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTableMFClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTableMFReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTableMFWriteRow;

} /* end ObitTableMFClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableMFUpdate (ObitTableMF *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   union ObitInfoListEquiv InfoReal; 

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
  in->depth1 = 1; 
  InfoReal.dbl = 1; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DEPTH1", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->depth1 = InfoReal.dbl;
  if (type==OBIT_float)  in->depth1 = InfoReal.flt;
  in->depth2 = 1; 
  InfoReal.dbl = 1; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DEPTH2", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->depth2 = InfoReal.dbl;
  if (type==OBIT_float)  in->depth2 = InfoReal.flt;
  in->depth3 = 1; 
  InfoReal.dbl = 1; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DEPTH3", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->depth3 = InfoReal.dbl;
  if (type==OBIT_float)  in->depth3 = InfoReal.flt;
  in->depth4 = 1; 
  InfoReal.dbl = 1; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DEPTH4", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->depth4 = InfoReal.dbl;
  if (type==OBIT_float)  in->depth4 = InfoReal.flt;
  in->depth5 = 1; 
  InfoReal.dbl = 1; 
  type = OBIT_double;
  ObitInfoListGetTest(in->myDesc->info, "DEPTH5", &type, dim, 
		       (gpointer)&InfoReal);
  if (type==OBIT_double) in->depth5 = InfoReal.dbl;
  if (type==OBIT_float)  in->depth5 = InfoReal.flt;

  /* initialize column numbers/offsets */
  in->planeOff = -1;
  in->planeCol = -1;
  in->PeakOff = -1;
  in->PeakCol = -1;
  in->IFluxOff = -1;
  in->IFluxCol = -1;
  in->DeltaXOff = -1;
  in->DeltaXCol = -1;
  in->DeltaYOff = -1;
  in->DeltaYCol = -1;
  in->MajorAxOff = -1;
  in->MajorAxCol = -1;
  in->MinorAxOff = -1;
  in->MinorAxCol = -1;
  in->PosAngleOff = -1;
  in->PosAngleCol = -1;
  in->QFluxOff = -1;
  in->QFluxCol = -1;
  in->UFluxOff = -1;
  in->UFluxCol = -1;
  in->VFluxOff = -1;
  in->VFluxCol = -1;
  in->errPeakOff = -1;
  in->errPeakCol = -1;
  in->errIFluxOff = -1;
  in->errIFluxCol = -1;
  in->errDeltaXOff = -1;
  in->errDeltaXCol = -1;
  in->errDeltaYOff = -1;
  in->errDeltaYCol = -1;
  in->errMajorAxOff = -1;
  in->errMajorAxCol = -1;
  in->errMinorAxOff = -1;
  in->errMinorAxCol = -1;
  in->errPosAngleOff = -1;
  in->errPosAngleCol = -1;
  in->errQFluxOff = -1;
  in->errQFluxCol = -1;
  in->errUFluxOff = -1;
  in->errUFluxCol = -1;
  in->errVFluxOff = -1;
  in->errVFluxCol = -1;
  in->TypeModOff = -1;
  in->TypeModCol = -1;
  in->D0MajorOff = -1;
  in->D0MajorCol = -1;
  in->D0MinorOff = -1;
  in->D0MinorCol = -1;
  in->D0PosAngleOff = -1;
  in->D0PosAngleCol = -1;
  in->DmMajorOff = -1;
  in->DmMajorCol = -1;
  in->DmMinorOff = -1;
  in->DmMinorCol = -1;
  in->DmPosAngleOff = -1;
  in->DmPosAngleCol = -1;
  in->DpMajorOff = -1;
  in->DpMajorCol = -1;
  in->DpMinorOff = -1;
  in->DpMinorCol = -1;
  in->DpPosAngleOff = -1;
  in->DpPosAngleCol = -1;
  in->ResRMSOff = -1;
  in->ResRMSCol = -1;
  in->ResPeakOff = -1;
  in->ResPeakCol = -1;
  in->ResFluxOff = -1;
  in->ResFluxCol = -1;
  in->PixelCenterXOff = -1;
  in->PixelCenterXCol = -1;
  in->PixelCenterYOff = -1;
  in->PixelCenterYCol = -1;
  in->PixelMajorAxisOff = -1;
  in->PixelMajorAxisCol = -1;
  in->PixelMinorAxisOff = -1;
  in->PixelMinorAxisCol = -1;
  in->PixelPosAngleOff = -1;
  in->PixelPosAngleCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "PLANE ", 6)) {
	 in->planeOff = desc->offset[i];
 	 in->planeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PEAK INT", 8)) {
	 in->PeakOff = desc->offset[i];
 	 in->PeakCol = i;
      }
      if (!strncmp (desc->FieldName[i], "I FLUX ", 7)) {
	 in->IFluxOff = desc->offset[i];
 	 in->IFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DELTAX ", 7)) {
	 in->DeltaXOff = desc->offset[i];
 	 in->DeltaXCol = i;
      }
      if (!strncmp (desc->FieldName[i], "DELTAY ", 7)) {
	 in->DeltaYOff = desc->offset[i];
 	 in->DeltaYCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MAJOR AX", 8)) {
	 in->MajorAxOff = desc->offset[i];
 	 in->MajorAxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MINOR AX", 8)) {
	 in->MinorAxOff = desc->offset[i];
 	 in->MinorAxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POSANGLE", 8)) {
	 in->PosAngleOff = desc->offset[i];
 	 in->PosAngleCol = i;
      }
      if (!strncmp (desc->FieldName[i], "Q FLUX  ", 8)) {
	 in->QFluxOff = desc->offset[i];
 	 in->QFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "U FLUX ", 7)) {
	 in->UFluxOff = desc->offset[i];
 	 in->UFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "V FLUX  ", 8)) {
	 in->VFluxOff = desc->offset[i];
 	 in->VFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR PEAK", 8)) {
	 in->errPeakOff = desc->offset[i];
 	 in->errPeakCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR FLUX", 8)) {
	 in->errIFluxOff = desc->offset[i];
 	 in->errIFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR DLTX", 8)) {
	 in->errDeltaXOff = desc->offset[i];
 	 in->errDeltaXCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR DLTY", 8)) {
	 in->errDeltaYOff = desc->offset[i];
 	 in->errDeltaYCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR MAJA", 8)) {
	 in->errMajorAxOff = desc->offset[i];
 	 in->errMajorAxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR MINA", 8)) {
	 in->errMinorAxOff = desc->offset[i];
 	 in->errMinorAxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR PA ", 7)) {
	 in->errPosAngleOff = desc->offset[i];
 	 in->errPosAngleCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR QFLX", 8)) {
	 in->errQFluxOff = desc->offset[i];
 	 in->errQFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR UFLX", 8)) {
	 in->errUFluxOff = desc->offset[i];
 	 in->errUFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ERR VFLX", 8)) {
	 in->errVFluxOff = desc->offset[i];
 	 in->errVFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TYPE MOD", 8)) {
	 in->TypeModOff = desc->offset[i];
 	 in->TypeModCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D0 MAJOR", 8)) {
	 in->D0MajorOff = desc->offset[i];
 	 in->D0MajorCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D0 MINOR", 8)) {
	 in->D0MinorOff = desc->offset[i];
 	 in->D0MinorCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D0 POSANG", 9)) {
	 in->D0PosAngleOff = desc->offset[i];
 	 in->D0PosAngleCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D- MAJOR", 8)) {
	 in->DmMajorOff = desc->offset[i];
 	 in->DmMajorCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D- MINOR", 8)) {
	 in->DmMinorOff = desc->offset[i];
 	 in->DmMinorCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D- POSAN", 8)) {
	 in->DmPosAngleOff = desc->offset[i];
 	 in->DmPosAngleCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D+ MAJOR", 8)) {
	 in->DpMajorOff = desc->offset[i];
 	 in->DpMajorCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D+ MINOR", 8)) {
	 in->DpMinorOff = desc->offset[i];
 	 in->DpMinorCol = i;
      }
      if (!strncmp (desc->FieldName[i], "D+ POSAN", 8)) {
	 in->DpPosAngleOff = desc->offset[i];
 	 in->DpPosAngleCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RES RMS ", 8)) {
	 in->ResRMSOff = desc->offset[i];
 	 in->ResRMSCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RES PEAK", 8)) {
	 in->ResPeakOff = desc->offset[i];
 	 in->ResPeakCol = i;
      }
      if (!strncmp (desc->FieldName[i], "RES FLUX", 8)) {
	 in->ResFluxOff = desc->offset[i];
 	 in->ResFluxCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CENTER X", 8)) {
	 in->PixelCenterXOff = desc->offset[i];
 	 in->PixelCenterXCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CENTER Y", 8)) {
	 in->PixelCenterYOff = desc->offset[i];
 	 in->PixelCenterYCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MAJ AXIS", 8)) {
	 in->PixelMajorAxisOff = desc->offset[i];
 	 in->PixelMajorAxisCol = i;
      }
      if (!strncmp (desc->FieldName[i], "MIN AXIS", 8)) {
	 in->PixelMinorAxisOff = desc->offset[i];
 	 in->PixelMinorAxisCol = i;
      }
      if (!strncmp (desc->FieldName[i], "PIXEL PA", 8)) {
	 in->PixelPosAngleOff = desc->offset[i];
 	 in->PixelPosAngleCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->planeOff > -1), err,
       "ObitTableMFUpdate: Could not find column plane");
  Obit_return_if_fail((in->PeakOff > -1), err,
       "ObitTableMFUpdate: Could not find column Peak");
  Obit_return_if_fail((in->IFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column IFlux");
  Obit_return_if_fail((in->DeltaXOff > -1), err,
       "ObitTableMFUpdate: Could not find column DeltaX");
  Obit_return_if_fail((in->DeltaYOff > -1), err,
       "ObitTableMFUpdate: Could not find column DeltaY");
  Obit_return_if_fail((in->MajorAxOff > -1), err,
       "ObitTableMFUpdate: Could not find column MajorAx");
  Obit_return_if_fail((in->MinorAxOff > -1), err,
       "ObitTableMFUpdate: Could not find column MinorAx");
  Obit_return_if_fail((in->PosAngleOff > -1), err,
       "ObitTableMFUpdate: Could not find column PosAngle");
  Obit_return_if_fail((in->QFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column QFlux");
  Obit_return_if_fail((in->UFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column UFlux");
  Obit_return_if_fail((in->VFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column VFlux");
  Obit_return_if_fail((in->errPeakOff > -1), err,
       "ObitTableMFUpdate: Could not find column errPeak");
  Obit_return_if_fail((in->errIFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column errIFlux");
  Obit_return_if_fail((in->errDeltaXOff > -1), err,
       "ObitTableMFUpdate: Could not find column errDeltaX");
  Obit_return_if_fail((in->errDeltaYOff > -1), err,
       "ObitTableMFUpdate: Could not find column errDeltaY");
  Obit_return_if_fail((in->errMajorAxOff > -1), err,
       "ObitTableMFUpdate: Could not find column errMajorAx");
  Obit_return_if_fail((in->errMinorAxOff > -1), err,
       "ObitTableMFUpdate: Could not find column errMinorAx");
  Obit_return_if_fail((in->errPosAngleOff > -1), err,
       "ObitTableMFUpdate: Could not find column errPosAngle");
  Obit_return_if_fail((in->errQFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column errQFlux");
  Obit_return_if_fail((in->errUFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column errUFlux");
  Obit_return_if_fail((in->errVFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column errVFlux");
  Obit_return_if_fail((in->TypeModOff > -1), err,
       "ObitTableMFUpdate: Could not find column TypeMod");
  Obit_return_if_fail((in->D0MajorOff > -1), err,
       "ObitTableMFUpdate: Could not find column D0Major");
  Obit_return_if_fail((in->D0MinorOff > -1), err,
       "ObitTableMFUpdate: Could not find column D0Minor");
  Obit_return_if_fail((in->D0PosAngleOff > -1), err,
       "ObitTableMFUpdate: Could not find column D0PosAngle");
  Obit_return_if_fail((in->DmMajorOff > -1), err,
       "ObitTableMFUpdate: Could not find column DmMajor");
  Obit_return_if_fail((in->DmMinorOff > -1), err,
       "ObitTableMFUpdate: Could not find column DmMinor");
  Obit_return_if_fail((in->DmPosAngleOff > -1), err,
       "ObitTableMFUpdate: Could not find column DmPosAngle");
  Obit_return_if_fail((in->DpMajorOff > -1), err,
       "ObitTableMFUpdate: Could not find column DpMajor");
  Obit_return_if_fail((in->DpMinorOff > -1), err,
       "ObitTableMFUpdate: Could not find column DpMinor");
  Obit_return_if_fail((in->DpPosAngleOff > -1), err,
       "ObitTableMFUpdate: Could not find column DpPosAngle");
  Obit_return_if_fail((in->ResRMSOff > -1), err,
       "ObitTableMFUpdate: Could not find column ResRMS");
  Obit_return_if_fail((in->ResPeakOff > -1), err,
       "ObitTableMFUpdate: Could not find column ResPeak");
  Obit_return_if_fail((in->ResFluxOff > -1), err,
       "ObitTableMFUpdate: Could not find column ResFlux");
  Obit_return_if_fail((in->PixelCenterXOff > -1), err,
       "ObitTableMFUpdate: Could not find column PixelCenterX");
  Obit_return_if_fail((in->PixelCenterYOff > -1), err,
       "ObitTableMFUpdate: Could not find column PixelCenterY");
  Obit_return_if_fail((in->PixelMajorAxisOff > -1), err,
       "ObitTableMFUpdate: Could not find column PixelMajorAxis");
  Obit_return_if_fail((in->PixelMinorAxisOff > -1), err,
       "ObitTableMFUpdate: Could not find column PixelMinorAxis");
} /* end ObitTableMFUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTableMFDumpKey (ObitTableMF *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* depth1 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DEPTH1", type, dim, 
		  (gpointer)&in->depth1);
  /* depth2 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DEPTH2", type, dim, 
		  (gpointer)&in->depth2);
  /* depth3 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DEPTH3", type, dim, 
		  (gpointer)&in->depth3);
  /* depth4 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DEPTH4", type, dim, 
		  (gpointer)&in->depth4);
  /* depth5 */
  type  = OBIT_float;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "DEPTH5", type, dim, 
		  (gpointer)&in->depth5);
   
} /* end ObitTableMFDumpKey */
