/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTablePC.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTablePC.c
 * ObitTablePC class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTablePC";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTablePCRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTablePCRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTablePCClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTablePCClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTablePCRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTablePCRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTablePCInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTablePCClear (gpointer in);

/** Private: update table specific info */
static void ObitTablePCUpdate (ObitTablePC *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTablePCDumpKey (ObitTablePC *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTablePCClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTablePCRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTablePCRow* newObitTablePCRow (ObitTablePC *table)
{
  ObitTablePCRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTablePCRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTablePCRow));

  /* initialize values */
  out->name = g_strdup("TablePC Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTablePCRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    if (table->numPol>=1) out->State1 = fRow + table->State1Off;
    if (table->numPol>=1) out->PCFreq1 = dRow + table->PCFreq1Off;
    if (table->numPol>=1) out->PCReal1 = fRow + table->PCReal1Off;
    if (table->numPol>=1) out->PCImag1 = fRow + table->PCImag1Off;
    if (table->numPol>=1) out->PCRate1 = fRow + table->PCRate1Off;
    if (table->numPol>=2) out->State2 = fRow + table->State2Off;
    if (table->numPol>=2) out->PCFreq2 = dRow + table->PCFreq2Off;
    if (table->numPol>=2) out->PCReal2 = fRow + table->PCReal2Off;
    if (table->numPol>=2) out->PCImag2 = fRow + table->PCImag2Off;
    if (table->numPol>=2) out->PCRate2 = fRow + table->PCRate2Off;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTablePCRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTablePCRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTablePCRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTablePCRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTablePC* newObitTablePC (gchar* name)
{
  ObitTablePC* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePCClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTablePC));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTablePCInit((gpointer)out);

 return out;
} /* end newObitTablePC */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTablePCGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePCClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitPCGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numPol The number of polarizations.
 * \param numBand The number of Bands(?).
 * \param numTones The number of Tones.
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTablePC* newObitTablePCValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numPol, oint numBand, oint numTones,
		     ObitErr *err)
{
  ObitTablePC* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS PC";
  gchar *routine = "newObitTablePCValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePCClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS PC");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTablePC */
      if (ObitTablePCIsA(testTab)) { /* it is an ObitTablePC */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTablePCConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS PC");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTablePCIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTablePCConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numPol = MAX (0, numPol);
  out->numBand = MAX (0, numBand);
  out->numTones = MAX (0, numTones);
  out->revision = 3;

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 6 + out->numPol*5 + out->numBand*0 + out->numTones*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCE_ID  ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA_NO");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ARRAY      ");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("FREQID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("CABLE_CAL");
  desc->FieldUnit[colNo] = g_strdup("SECONDS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("STATE_1");
    desc->FieldUnit[colNo] = g_strdup("PERCENT");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 4;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PC_FREQ_1");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PC_REAL_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PC_IMAG_1");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=1) {
    desc->FieldName[colNo] = g_strdup("PC_RATE_1");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("STATE_2");
    desc->FieldUnit[colNo] = g_strdup("PERCENT");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 4;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PC_FREQ_2");
    desc->FieldUnit[colNo] = g_strdup("HZ");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PC_REAL_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PC_IMAG_2");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  if (numPol>=2) {
    desc->FieldName[colNo] = g_strdup("PC_RATE_2");
    desc->FieldUnit[colNo] = g_strdup("SEC/SEC");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = numTones;
    desc->dim[colNo][1] = numBand;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTablePCDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTablePCOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTablePCClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTablePCValue */

/**
 * Convert an ObitTable to an ObitTablePC.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTablePC* ObitTablePCConvert (ObitTable* in)
{
  ObitTablePC *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTablePC(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTablePCConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTablePC* ObitTablePCCopy (ObitTablePC *in, ObitTablePC *out, ObitErr *err)
{
  gchar *routine = "ObitTablePCCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePCClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTablePC*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  out->numPol = in->numPol;
  out->numBand = in->numBand;
  out->numTones = in->numTones;
  /* Update class specific info */
  ObitTablePCUpdate (out, err);
    
  return out;
} /* end ObitTablePCCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTablePCOpen (ObitTablePC *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTablePCOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePCClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTablePCUpdate (in, err);
   
   return retCode;
} /* end ObitTablePCOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iPCRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTablePCReadRow  (ObitTablePC *in, olong iPCRow, ObitTablePCRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTablePCReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS PC Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iPCRow */
  retCode = ObitTableRead ((ObitTable*)in, iPCRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->SourID = iRow[in->SourIDOff];
  row->antennaNo = iRow[in->antennaNoOff];
  row->Array = iRow[in->ArrayOff];
  row->FreqID = iRow[in->FreqIDOff];
  row->CableCal = dRow[in->CableCalOff];
  if (in->numPol>=1) row->State1 = fRow + in->State1Off;
  if (in->numPol>=1) row->PCFreq1 = dRow + in->PCFreq1Off;
  if (in->numPol>=1) row->PCReal1 = fRow + in->PCReal1Off;
  if (in->numPol>=1) row->PCImag1 = fRow + in->PCImag1Off;
  if (in->numPol>=1) row->PCRate1 = fRow + in->PCRate1Off;
  if (in->numPol>=2) row->State2 = fRow + in->State2Off;
  if (in->numPol>=2) row->PCFreq2 = dRow + in->PCFreq2Off;
  if (in->numPol>=2) row->PCReal2 = fRow + in->PCReal2Off;
  if (in->numPol>=2) row->PCImag2 = fRow + in->PCImag2Off;
  if (in->numPol>=2) row->PCRate2 = fRow + in->PCRate2Off;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTablePCReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTablePCSetRow  (ObitTablePC *in, ObitTablePCRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "PC Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  if (in->numPol>=1) row->State1 = fRow + in->State1Off;
  if (in->numPol>=1) row->PCFreq1 = dRow + in->PCFreq1Off;
  if (in->numPol>=1) row->PCReal1 = fRow + in->PCReal1Off;
  if (in->numPol>=1) row->PCImag1 = fRow + in->PCImag1Off;
  if (in->numPol>=1) row->PCRate1 = fRow + in->PCRate1Off;
  if (in->numPol>=2) row->State2 = fRow + in->State2Off;
  if (in->numPol>=2) row->PCFreq2 = dRow + in->PCFreq2Off;
  if (in->numPol>=2) row->PCReal2 = fRow + in->PCReal2Off;
  if (in->numPol>=2) row->PCImag2 = fRow + in->PCImag2Off;
  if (in->numPol>=2) row->PCRate2 = fRow + in->PCRate2Off;

} /*  end ObitTablePCSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTablePCSetRow  
 * \param in       Table to read
 * \param iPCRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTablePCWriteRow  (ObitTablePC *in, olong iPCRow, ObitTablePCRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTablePCWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS PC Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  iRow[in->SourIDOff] = row->SourID;
  iRow[in->antennaNoOff] = row->antennaNo;
  iRow[in->ArrayOff] = row->Array;
  iRow[in->FreqIDOff] = row->FreqID;
  dRow[in->CableCalOff] = row->CableCal;
  if (in->numPol>=1)
    if (in->State1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->State1Col]; i++) 
        fRow[in->State1Off+i] = row->State1[i];
    } 
  if (in->numPol>=1)
    if (in->PCFreq1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCFreq1Col]; i++) 
        dRow[in->PCFreq1Off+i] = row->PCFreq1[i];
    } 
  if (in->numPol>=1)
    if (in->PCReal1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCReal1Col]; i++) 
        fRow[in->PCReal1Off+i] = row->PCReal1[i];
    } 
  if (in->numPol>=1)
    if (in->PCImag1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCImag1Col]; i++) 
        fRow[in->PCImag1Off+i] = row->PCImag1[i];
    } 
  if (in->numPol>=1)
    if (in->PCRate1Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCRate1Col]; i++) 
        fRow[in->PCRate1Off+i] = row->PCRate1[i];
    } 
  if (in->numPol>=2)
    if (in->State2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->State2Col]; i++) 
        fRow[in->State2Off+i] = row->State2[i];
    } 
  if (in->numPol>=2)
    if (in->PCFreq2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCFreq2Col]; i++) 
        dRow[in->PCFreq2Off+i] = row->PCFreq2[i];
    } 
  if (in->numPol>=2)
    if (in->PCReal2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCReal2Col]; i++) 
        fRow[in->PCReal2Off+i] = row->PCReal2[i];
    } 
  if (in->numPol>=2)
    if (in->PCImag2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCImag2Col]; i++) 
        fRow[in->PCImag2Off+i] = row->PCImag2[i];
    } 
  if (in->numPol>=2)
    if (in->PCRate2Col >= 0) { 
      for (i=0; i<in->myDesc->repeat[in->PCRate2Col]; i++) 
        fRow[in->PCRate2Off+i] = row->PCRate2[i];
    } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iPCRow */
  retCode = ObitTableWrite ((ObitTable*)in, iPCRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTablePCWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTablePCClose (ObitTablePC *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTablePCClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTablePCDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTablePCClose */

/*---------------Private functions--------------------------*/
/*----------------  TablePC Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTablePCRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePCRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->State1 = NULL;
  in->PCFreq1 = NULL;
  in->PCReal1 = NULL;
  in->PCImag1 = NULL;
  in->PCRate1 = NULL;
  in->State2 = NULL;
  in->PCFreq2 = NULL;
  in->PCReal2 = NULL;
  in->PCImag2 = NULL;
  in->PCRate2 = NULL;

} /* end ObitTablePCRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTablePCRow* cast to an Obit*.
 */
void ObitTablePCRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePCRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTablePCRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTablePCRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTablePCRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTablePCRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTablePCRowClassInfoDefFn (gpointer inClass)
{
  ObitTablePCRowClassInfo *theClass = (ObitTablePCRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTablePCRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTablePCRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTablePCRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTablePCRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTablePCRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTablePCRowInit;

} /* end ObitTablePCRowClassDefFn */

/*------------------  TablePC  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTablePCInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePC *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTablePCInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTablePC* cast to an Obit*.
 */
void ObitTablePCClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePC *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTablePCClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTablePCClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTablePCClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTablePCClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTablePCClassInfoDefFn (gpointer inClass)
{
  ObitTablePCClassInfo *theClass = (ObitTablePCClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTablePCClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTablePCClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTablePCGetClass;
  theClass->newObit       = (newObitFP)newObitTablePC;
  theClass->ObitCopy      = (ObitCopyFP)ObitTablePCCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTablePCClear;
  theClass->ObitInit      = (ObitInitFP)ObitTablePCInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTablePCConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTablePCOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTablePCClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTablePCReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTablePCWriteRow;

} /* end ObitTablePCClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTablePCUpdate (ObitTablePC *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 3; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);
   /* numPol */
  in->numPol = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_POL", &type, dim, 
		       (gpointer)&in->numPol);
   /* numBand */
  in->numBand = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_BAND", &type, dim, 
		       (gpointer)&in->numBand);
   /* numTones */
  in->numTones = 1; 
  ObitInfoListGetTest(in->myDesc->info, "NO_TONES", &type, dim, 
		       (gpointer)&in->numTones);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->SourIDOff = -1;
  in->SourIDCol = -1;
  in->antennaNoOff = -1;
  in->antennaNoCol = -1;
  in->ArrayOff = -1;
  in->ArrayCol = -1;
  in->FreqIDOff = -1;
  in->FreqIDCol = -1;
  in->CableCalOff = -1;
  in->CableCalCol = -1;
  in->State1Off = -1;
  in->State1Col = -1;
  in->PCFreq1Off = -1;
  in->PCFreq1Col = -1;
  in->PCReal1Off = -1;
  in->PCReal1Col = -1;
  in->PCImag1Off = -1;
  in->PCImag1Col = -1;
  in->PCRate1Off = -1;
  in->PCRate1Col = -1;
  in->State2Off = -1;
  in->State2Col = -1;
  in->PCFreq2Off = -1;
  in->PCFreq2Col = -1;
  in->PCReal2Off = -1;
  in->PCReal2Col = -1;
  in->PCImag2Off = -1;
  in->PCImag2Col = -1;
  in->PCRate2Off = -1;
  in->PCRate2Col = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCE_ID  ", 11)) {
	 in->SourIDOff = desc->offset[i];
 	 in->SourIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA_NO", 10)) {
	 in->antennaNoOff = desc->offset[i];
 	 in->antennaNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ARRAY      ", 11)) {
	 in->ArrayOff = desc->offset[i];
 	 in->ArrayCol = i;
      }
      if (!strncmp (desc->FieldName[i], "FREQID", 6)) {
	 in->FreqIDOff = desc->offset[i];
 	 in->FreqIDCol = i;
      }
      if (!strncmp (desc->FieldName[i], "CABLE_CAL", 9)) {
	 in->CableCalOff = desc->offset[i];
 	 in->CableCalCol = i;
      }
      if (!strncmp (desc->FieldName[i], "STATE_1", 7)) {
	     in->State1Off = desc->offset[i];
 	     in->State1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_FREQ_1", 9)) {
	     in->PCFreq1Off = desc->offset[i];
 	     in->PCFreq1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_REAL_1", 9)) {
	     in->PCReal1Off = desc->offset[i];
 	     in->PCReal1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_IMAG_1", 9)) {
	     in->PCImag1Off = desc->offset[i];
 	     in->PCImag1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_RATE_1", 9)) {
	     in->PCRate1Off = desc->offset[i];
 	     in->PCRate1Col = i;
      }
      if (!strncmp (desc->FieldName[i], "STATE_2", 7)) {
	     in->State2Off = desc->offset[i];
 	     in->State2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_FREQ_2", 9)) {
	     in->PCFreq2Off = desc->offset[i];
 	     in->PCFreq2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_REAL_2", 9)) {
	     in->PCReal2Off = desc->offset[i];
 	     in->PCReal2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_IMAG_2", 9)) {
	     in->PCImag2Off = desc->offset[i];
 	     in->PCImag2Col = i;
      }
      if (!strncmp (desc->FieldName[i], "PC_RATE_2", 9)) {
	     in->PCRate2Off = desc->offset[i];
 	     in->PCRate2Col = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTablePCUpdate: Could not find column Time");
  Obit_return_if_fail((in->SourIDOff > -1), err,
       "ObitTablePCUpdate: Could not find column SourID");
  Obit_return_if_fail((in->antennaNoOff > -1), err,
       "ObitTablePCUpdate: Could not find column antennaNo");
  Obit_return_if_fail((in->ArrayOff > -1), err,
       "ObitTablePCUpdate: Could not find column Array");
  Obit_return_if_fail((in->FreqIDOff > -1), err,
       "ObitTablePCUpdate: Could not find column FreqID");
  Obit_return_if_fail((in->CableCalOff > -1), err,
       "ObitTablePCUpdate: Could not find column CableCal");
  if (in->numPol>=1) {
    Obit_return_if_fail((in->State1Off > -1), err,
       "ObitTablePCUpdate: Could not find column State1");
    Obit_return_if_fail((in->PCFreq1Off > -1), err,
       "ObitTablePCUpdate: Could not find column PCFreq1");
    Obit_return_if_fail((in->PCReal1Off > -1), err,
       "ObitTablePCUpdate: Could not find column PCReal1");
    Obit_return_if_fail((in->PCImag1Off > -1), err,
       "ObitTablePCUpdate: Could not find column PCImag1");
  } /* end of if index in range */
  if (in->numPol>=2) {
    Obit_return_if_fail((in->State2Off > -1), err,
       "ObitTablePCUpdate: Could not find column State2");
    Obit_return_if_fail((in->PCFreq2Off > -1), err,
       "ObitTablePCUpdate: Could not find column PCFreq2");
    Obit_return_if_fail((in->PCReal2Off > -1), err,
       "ObitTablePCUpdate: Could not find column PCReal2");
    Obit_return_if_fail((in->PCImag2Off > -1), err,
       "ObitTablePCUpdate: Could not find column PCImag2");
  } /* end of if index in range */
} /* end ObitTablePCUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTablePCDumpKey (ObitTablePC *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
  /* numPol */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_POL", type, dim, 
		  (gpointer)&in->numPol);
  /* numBand */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_BAND", type, dim, 
		  (gpointer)&in->numBand);
  /* numTones */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_TONES", type, dim, 
		  (gpointer)&in->numTones);
   
} /* end ObitTablePCDumpKey */
