/* $Id:  $   */
/* DO NOT EDIT - file generated by ObitTables.pl                      */
/*--------------------------------------------------------------------*/
/*;  Copyright (C)  2019                                              */
/*;  Associated Universities, Inc. Washington DC, USA.                */
/*;                                                                   */
/*;  This program is free software; you can redistribute it and/or    */
/*;  modify it under the terms of the GNU General Public License as   */
/*;  published by the Free Software Foundation; either version 2 of   */
/*;  the License, or (at your option) any later version.              */
/*;                                                                   */
/*;  This program is distributed in the hope that it will be useful,  */
/*;  but WITHOUT ANY WARRANTY; without even the implied warranty of   */
/*;  MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the    */
/*;  GNU General Public License for more details.                     */
/*;                                                                   */
/*;  You should have received a copy of the GNU General Public        */
/*;  License along with this program; if not, write to the Free       */
/*;  Software Foundation, Inc., 675 Massachusetts Ave, Cambridge,     */
/*;  MA 02139, USA.                                                   */
/*;                                                                   */
/*;Correspondence about this software should be addressed as follows: */
/*;         Internet email: bcotton@nrao.edu.                         */
/*;         Postal address: William Cotton                            */
/*;                         National Radio Astronomy Observatory      */
/*;                         520 Edgemont Road                         */
/*;                         Charlottesville, VA 22903-2475 USA        */
/*--------------------------------------------------------------------*/
#include "ObitTablePT.h"
#include "ObitTableList.h"
#include "ObitData.h"

/*----------------Obit:  Merx mollis mortibus nuper ------------------*/
/**
 * \file ObitTablePT.c
 * ObitTablePT class function definitions.
 *
 * This class is derived from the #ObitTable class.
 */

/** name of the class defined in this file */
static gchar *myClassName = "ObitTablePT";

/**  Function to obtain parent Table ClassInfo - ObitTable */
static ObitGetClassFP ObitParentGetClass = ObitTableGetClass;

/** name of the Row class defined in this file */
static gchar *myRowClassName = "ObitTablePTRow";

/**  Function to obtain parent TableRow ClassInfo */
static ObitGetClassFP ObitParentGetRowClass = ObitTableRowGetClass;

/*--------------- File Global Variables  ----------------*/
/*----------------  Table Row  ----------------------*/
/**
 * ClassInfo structure ObitTableClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTablePTRowClassInfo myRowClassInfo = {FALSE};

/*------------------  Table  ------------------------*/
/**
 * ClassInfo structure ObitTablePTClassInfo.
 * This structure is used by class objects to access class functions.
 */
static ObitTablePTClassInfo myClassInfo = {FALSE};

/*---------------Private function prototypes----------------*/
/** Private: Initialize newly instantiated Row object. */
void  ObitTablePTRowInit  (gpointer in);

/** Private: Deallocate Row members. */
void  ObitTablePTRowClear (gpointer in);

/** Private: Initialize newly instantiated object. */
void  ObitTablePTInit  (gpointer in);

/** Private: Deallocate members. */
void  ObitTablePTClear (gpointer in);

/** Private: update table specific info */
static void ObitTablePTUpdate (ObitTablePT *in, ObitErr *err);

/** Private: copy table keywords to descriptor info list */
static void ObitTablePTDumpKey (ObitTablePT *in, ObitErr *err);

/** Private: Set Class function pointers */
static void ObitTablePTClassInfoDefFn (gpointer inClass);

/** Private: Set Row Class function pointers */
static void ObitTablePTRowClassInfoDefFn (gpointer inClass);
/*----------------------Public functions---------------------------*/

/*------------------  Table Row ------------------------*/
/**
 * Constructor.
 * If table is open and for write, the row is attached to the buffer
 * Initializes Row class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTablePTRow* newObitTablePTRow (ObitTablePT *table)
{
  ObitTablePTRow* out;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;

  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTablePTRowClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTablePTRow));

  /* initialize values */
  out->name = g_strdup("TablePT Row");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myRowClassInfo;

  /* initialize other stuff */
  ObitTablePTRowInit((gpointer)out);
  out->myTable   = (ObitTable*)ObitTableRef((ObitTable*)table);

  /* If writing attach to buffer */
  if ((table->buffer) && (table->myDesc->access != OBIT_IO_ReadOnly) &&
      (table->myStatus != OBIT_Inactive)) {
    /* Typed pointers to row of data */  
    dRow  = (odouble*)table->buffer;
    iRow  = (oint*)table->buffer;
    siRow = (gshort*)table->buffer;
    fRow  = (ofloat*)table->buffer;
    cRow  = (gchar*)table->buffer;
    lRow  = (gboolean*)table->buffer;
    bRow  = (guint8*)table->buffer;
  
    /* Set row pointers to buffer */
    out->Encoder = fRow + table->EncoderOff;
    out->PointingDirection = dRow + table->PointingDirectionOff;
    out->target = dRow + table->targetOff;
    out->offset = dRow + table->offsetOff;
    out->SourceOffset = dRow + table->SourceOffsetOff;
    out->sampledTimeInterval = dRow + table->sampledTimeIntervalOff;
    out->AtmosphericCorrection = fRow + table->AtmosphericCorrectionOff;
  } /* end attaching row to table buffer */

 return out;
} /* end newObitTablePTRow */

/**
 * Returns ClassInfo pointer for the Row class.
 * \return pointer to the Row class structure.
 */
gconstpointer ObitTablePTRowGetClass (void)
{
  /* Class initialization if needed */
  if (!myRowClassInfo.initialized) ObitTablePTRowClassInit();
  return (gconstpointer)&myRowClassInfo;
} /* end ObitTablePTRowGetClass */

/*------------------  Table  ------------------------*/
/**
 * Constructor.
 * Initializes class if needed on first call.
 * \param name An optional name for the object.
 * \return the new object.
 */
ObitTablePT* newObitTablePT (gchar* name)
{
  ObitTablePT* out;

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePTClassInit();

  /* allocate/init structure */
  out = g_malloc0(sizeof(ObitTablePT));

  /* initialize values */
  if (name!=NULL) out->name = g_strdup(name);
  else out->name = g_strdup("Noname");

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* initialize other stuff */
  ObitTablePTInit((gpointer)out);

 return out;
} /* end newObitTablePT */

/**
 * Returns ClassInfo pointer for the class.
 * \return pointer to the class structure.
 */
gconstpointer ObitTablePTGetClass (void)
{
  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePTClassInit();

  return (gconstpointer)&myClassInfo;
} /* end ObitPTGetClass */

/**
 * Constructor from values.
 * Creates a new table structure and attaches to the TableList of file.
 * If the specified table already exists then it is returned.
 * Initializes class if needed on first call.
 * Forces an update of any disk resident structures (e.g. AIPS header).
 * \param name   An optional name for the object.
 * \param file   ObitData which which the table is to be associated.
 * \param ver    Table version number. 0=> add higher, value used returned
 * \param access access (OBIT_IO_ReadOnly, means do not create if it doesn't exist.
 * \param numTerm The number of terms in model polynomial
 * \param err Error stack, returns if not empty.
 * \return the new object, NULL on failure.
 */
ObitTablePT* newObitTablePTValue (gchar* name, ObitData *file, olong *ver,
 	                    ObitIOAccess access,
  		     oint numTerm,
		     ObitErr *err)
{
  ObitTablePT* out=NULL;
  ObitTable *testTab=NULL;
  ObitTableDesc *desc=NULL;
  ObitTableList *list=NULL;
  ObitInfoList  *info=NULL;
  gboolean exist, optional;
  olong colNo, i, ncol, highVer;
  ObitIOCode retCode;
  gchar *tabType = "AIPS PT";
  gchar *routine = "newObitTablePTValue";

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitDataIsA(file));

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePTClassInit();

  /* Check if the table already exists */
  /* Get TableList */
  list = ((ObitData*)file)->tableList;
  info = ((ObitData*)file)->info;

  /* Get highest version number if not specified */
  if (*ver==0) { 
    highVer = ObitTableListGetHigh (list, "AIPS PT");
    if (access==OBIT_IO_ReadOnly) *ver = highVer;
    else if (access==OBIT_IO_ReadWrite) *ver = highVer;
    else if (access==OBIT_IO_WriteOnly) *ver = highVer+1;
  }
  /* See if it already exists */
  exist = FALSE;
  if (*ver>0) { /* has to be specified */
    exist = ObitTableListGet(list, tabType, ver, &testTab, err);
    if (err->error) /* add traceback,return */
      Obit_traceback_val (err, routine,"", out);
  
    /* if readonly, it must exist to proceed */
    if ((access==OBIT_IO_ReadOnly) && !exist) return out;
    if (testTab!=NULL) { /* it exists, use it if is an ObitTablePT */
      if (ObitTablePTIsA(testTab)) { /* it is an ObitTablePT */
	out = ObitTableRef(testTab);
      } else { /* needs conversion */
 	out = ObitTablePTConvert(testTab);
	/* Update the TableList */
	ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
	if (err->error) /* add traceback,return */
	  Obit_traceback_val (err, routine,"", out);
      }
      testTab = ObitTableUnref(testTab); /* remove reference */
      return out; /* done */
    }
  } /* end of test for previously existing table */
  
  /* If access is ReadOnly make sure one exists */
  if (access==OBIT_IO_ReadOnly) { 
    highVer = ObitTableListGetHigh (list, "AIPS PT");
    if (highVer<=0) return out;
  }
  
  /* create basal table */
  testTab = newObitDataTable ((ObitData*)file, access, tabType,
			       ver, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);
  
  /* likely need to convert */
  if (ObitTablePTIsA(testTab)) { 
    out = ObitTableRef(testTab);
  } else { /* needs conversion */
    out = ObitTablePTConvert(testTab);
  }
  testTab = ObitTableUnref(testTab); /* remove reference */

  /* Update the TableList */
  ObitTableListPut(list, tabType, ver, (ObitTable*)out, err);
  if (err->error) Obit_traceback_val (err, routine,"", out);

  /* if it previously existed merely return it */
  if (exist) return out; 

  /* set ClassInfo */
  out->ClassInfo = (gpointer)&myClassInfo;

  /* Set values */
  out->numTerm = MAX (0, numTerm);
  out->revision = 1;
  strncpy (out->RefDate, "YYYYMMDD", MAXKEYCHARTABLEPT );

  /* initialize descriptor */
  desc = out->myDesc;
  /* How many columns actually in table? */
  ncol = 17 + out->numTerm*0 ;
  desc->FieldName = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->FieldUnit = g_malloc0((ncol+1)*sizeof(gchar*));
  desc->type      = g_malloc0((ncol+1)*sizeof(ObitInfoType));
  desc->dim       = g_malloc0((ncol+1)*sizeof(gint32*));
  for (i=0; i<ncol+1; i++) 
    desc->dim[i] = g_malloc0(MAXINFOELEMDIM*sizeof(gint32));

  desc->TableName = g_strdup(tabType);
  desc->sort[0] = 0;
  desc->sort[1] = 0;
  colNo = 0;

  /* Define Columns */
  desc->FieldName[colNo] = g_strdup("TIME    ");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIME INTERVAL");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_float;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("ANTENNA NO.");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ENCODER");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("POINTINGTRACKING");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_bool;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("USEPOLYNOMIALS");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_bool;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("TIMEORIGIN");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = FALSE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("POINTINGDIRECTION");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    desc->dim[colNo][1] = numTerm;
    colNo++;
  }
  optional = FALSE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("TARGET");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    desc->dim[colNo][1] = numTerm;
    colNo++;
  }
  optional = FALSE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("OFFSET");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    desc->dim[colNo][1] = numTerm;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("POINTINGMODELID");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("OVERTHETOP");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_bool;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = TRUE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("SOURCEOFFSET");
    desc->FieldUnit[colNo] = g_strdup("");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    desc->dim[colNo][1] = numTerm;
    colNo++;
  }
  desc->FieldName[colNo] = g_strdup("SOURCEREFERENCECODEOFF");
  desc->FieldUnit[colNo] = g_strdup("");
  desc->type[colNo] = OBIT_oint;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  desc->FieldName[colNo] = g_strdup("SOURCEEQUINOXOFFSET");
  desc->FieldUnit[colNo] = g_strdup("DAYS");
  desc->type[colNo] = OBIT_double;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  colNo++;
  optional = TRUE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("SAMPLEDTIMEINTERVAL");
    desc->FieldUnit[colNo] = g_strdup("DAYS");
    desc->type[colNo] = OBIT_double;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    colNo++;
  }
  optional = TRUE;
  if ((2 > 0) || (!optional)) {
    desc->FieldName[colNo] = g_strdup("ATMOSPHERICCORRECTION");
    desc->FieldUnit[colNo] = g_strdup("DEGREES");
    desc->type[colNo] = OBIT_float;
    for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
    desc->dim[colNo][0] = 2;
    colNo++;
  }
  /* Add _status column at end */
  desc->FieldName[colNo] = g_strdup("_status");
  desc->FieldUnit[colNo] = g_strdup("        ");
  desc->type[colNo] = OBIT_long;
  for (i=0; i<MAXINFOELEMDIM; i++) desc->dim[colNo][i] = 1;
  
  /* number of fields */
  desc->nfield = colNo + 1;

  /* initialize descriptor keywords */
  ObitTablePTDumpKey (out, err);
 
  /* index table descriptor */
  ObitTableDescIndex (desc);

  /* Open and Close to fully instantiate */
  retCode = ObitTablePTOpen(out, OBIT_IO_WriteOnly, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out);    
  
  retCode = ObitTablePTClose(out, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 

  /* Force update of disk resident info */
  retCode = ObitIOUpdateTables (((ObitData*)file)->myIO, info, err);
  if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
    Obit_traceback_val (err, routine, out->name, out); 
  
 return out;
} /* end newObitTablePTValue */

/**
 * Convert an ObitTable to an ObitTablePT.
 * New object will have references to members of in.
 * \param in  The object to copy, will still exist afterwards 
 *            and should be Unrefed if not needed.
 * \return pointer to the new object.
 */
ObitTablePT* ObitTablePTConvert (ObitTable* in)
{
  ObitTablePT *out;

  /* error check */
  g_assert(ObitTableIsA(in));

  /* create basic object */
  out = newObitTablePT(in->name);

  /* Delete structures on new */
  out->info   = ObitInfoListUnref(out->info);
  out->thread = ObitThreadUnref(out->thread);
  out->myDesc = ObitTableDescUnref(out->myDesc);
  out->mySel  = ObitTableSelUnref(out->mySel);
  
  /* Reference members of in */
  
  out->info   = ObitInfoListRef(in->info);
  out->thread = ObitThreadRef(in->thread);
  out->myDesc = ObitTableDescRef(in->myDesc);
  out->mySel  = ObitTableSelRef(in->mySel);

  /* Remember who I am */
 out->tabType = g_strdup(in->tabType);
 out->tabVer  = in->tabVer;
  /* Secret reference to host */ 
 out->myHost  = in->myHost;

  return out;
} /* end ObitTablePTConvert */


/**
 * Make a deep copy of input object.
 * Copies are made of complex members including disk files; these 
 * will be copied applying whatever selection is associated with the input.
 * Objects should be closed on input and will be closed on output.
 * In order for the disk file structures to be copied, the output file
 * must be sufficiently defined that it can be written.
 * The copy will be attempted but no errors will be logged until
 * both input and output have been successfully opened.
 * ObitInfoList and ObitThread members are only copied if the output object
 * didn't previously exist.
 * Parent class members are included but any derived class info is ignored.
 * \param in  The object to copy
 * \param out An existing object pointer for output or NULL if none exists.
 * \param err Error stack, returns if not empty.
 * \return pointer to the new object.
 */
ObitTablePT* ObitTablePTCopy (ObitTablePT *in, ObitTablePT *out, ObitErr *err)
{
  gchar *routine = "ObitTablePTCopy";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePTClassInit();

 /* error checks */
  g_assert(ObitErrIsA(err));
  if (err->error) return NULL;
  g_assert (ObitIsA(in, &myClassInfo));
  if (out) g_assert (ObitIsA(out, &myClassInfo));

  /* Use parent class to copy */
  out = (ObitTablePT*)ObitTableCopy ((ObitTable*)in, (ObitTable*)out, err);
  if (err->error) /* add traceback,return */
    Obit_traceback_val (err, routine,in->name, out);

  /* Copy this class  info */
  out->revision = in->revision;
  out->numTerm = in->numTerm;
  strncpy (out->RefDate, in->RefDate, MAXKEYCHARTABLEPT );
  /* Update class specific info */
  ObitTablePTUpdate (out, err);
    
  return out;
} /* end ObitTablePTCopy */

/**
 * Initialize structures and open file.
 * The image descriptor is read if OBIT_IO_ReadOnly or 
 * OBIT_IO_ReadWrite and written to disk if opened OBIT_IO_WriteOnly.
 * After the file has been opened the member, buffer is initialized
 * for reading/storing the table unless member bufferSize is <0.
 * If the requested version ("Ver" in InfoList) is 0 then the highest
 * numbered table of the same type is opened on Read or Read/Write, 
 * or a new table is created on on Write.
 * The file etc. info should have been stored in the ObitInfoList:
 * \li "FileType" OBIT_long scalar = OBIT_IO_FITS or OBIT_IO_AIPS 
 *               for file type (see class documentation for details).
 * \li "nRowPIO" OBIT_long scalar = Maximum number of table rows
 *               per transfer, this is the target size for Reads (may be 
 *               fewer) and is used to create buffers.
 * \param in Pointer to object to be opened.
 * \param access access (OBIT_IO_ReadOnly,OBIT_IO_ReadWrite,
 *               or OBIT_IO_WriteOnly).
 *               If OBIT_IO_WriteOnly any existing data in the output file
 *               will be lost.
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTablePTOpen (ObitTablePT *in, ObitIOAccess access, 
			  ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};
  olong nRowPIO;
  gchar *routine = "ObitTablePTOpen";

  /* Class initialization if needed */
  if (!myClassInfo.initialized) ObitTablePTClassInit();

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

   /* Do one row at a time */
   nRowPIO = 1;
   ObitInfoListPut(in->info, "nRowPIO", OBIT_long, dim, (gconstpointer)&nRowPIO, err);
   if (err->error) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* use parent class open */
   retCode = ObitTableOpen ((ObitTable*)in, access, err);
   if ((retCode!=OBIT_IO_OK) || (err->error)) /* add traceback,return */
     Obit_traceback_val (err, routine, in->name, retCode);
   
   /* Update class specific info */
   ObitTablePTUpdate (in, err);
   
   return retCode;
} /* end ObitTablePTOpen */

/**
 * Read a table row and return an easily digested version.
 * Scalar values are copied but for array values, pointers 
 * into the data array are returned.
 * \param in       Table to read
 * \param iPTRow   Row number, -1 -> next
 * \param row      Table Row structure to receive data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTablePTReadRow  (ObitTablePT *in, olong iPTRow, ObitTablePTRow *row,
		     ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTablePTReadRow";
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS PT Table is inactive for  %s ", in->name);
    return retCode;
 }

  /* read row iPTRow */
  retCode = ObitTableRead ((ObitTable*)in, iPTRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Copy scalar fields, for arrays only set pointer*/
  row->Time = dRow[in->TimeOff];
  row->TimeI = fRow[in->TimeIOff];
  row->antNo = iRow[in->antNoOff];
  row->pointingTracking = lRow[in->pointingTrackingOff];
  row->usePolynomials = lRow[in->usePolynomialsOff];
  row->timeOrigin = dRow[in->timeOriginOff];
  row->pointingModelId = iRow[in->pointingModelIdOff];
  row->overTheTop = lRow[in->overTheTopOff];
  row->SourceReferenceCodeOffset = iRow[in->SourceReferenceCodeOffsetOff];
  row->sourceEquinoxOffset = dRow[in->sourceEquinoxOffsetOff];
  row->Encoder = fRow + in->EncoderOff;
  row->PointingDirection = dRow + in->PointingDirectionOff;
  row->target = dRow + in->targetOff;
  row->offset = dRow + in->offsetOff;
  row->SourceOffset = dRow + in->SourceOffsetOff;
  row->sampledTimeInterval = dRow + in->sampledTimeIntervalOff;
  row->AtmosphericCorrection = fRow + in->AtmosphericCorrectionOff;
  row->status = iRow[in->myDesc->statusOff];

  return retCode;
} /*  end ObitTablePTReadRow */

/**
 * Attach an ObitTableRow to the buffer of an ObitTable.
 * This is only useful prior to filling a row structure in preparation .
 * for a WriteRow operation.  Array members of the Row structure are .
 * pointers to independently allocated memory, this routine allows using .
 * the table IO buffer instead of allocating yet more memory..
 * This routine need only be called once to initialize a Row structure for write..
 * \param in  Table with buffer to be written 
 * \param row Table Row structure to attach 
 * \param err ObitErr for reporting errors.
 */
void 
ObitTablePTSetRow  (ObitTablePT *in, ObitTablePTRow *row,
		     ObitErr *err)
{
  odouble   *dRow;
  oint      *iRow;
  gshort    *siRow;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  
  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));
  g_assert (ObitIsA(row, &myRowClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "PT Table is inactive for  %s ", in->name);
    return;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  iRow  = (oint*)in->buffer;
  siRow = (gshort*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Set row pointers to buffer */
  row->Encoder = fRow + in->EncoderOff;
  row->PointingDirection = dRow + in->PointingDirectionOff;
  row->target = dRow + in->targetOff;
  row->offset = dRow + in->offsetOff;
  row->SourceOffset = dRow + in->SourceOffsetOff;
  row->sampledTimeInterval = dRow + in->sampledTimeIntervalOff;
  row->AtmosphericCorrection = fRow + in->AtmosphericCorrectionOff;

} /*  end ObitTablePTSetRow */

/**
 * Write a table row.
 * Before calling this routine, the row structure needs to be initialized
 * and filled with data. The array members of the row structure are  
 * pointers to independently allocated memory.  These pointers can be set to the 
 * correct table buffer locations using ObitTablePTSetRow  
 * \param in       Table to read
 * \param iPTRow   Row number, -1 -> next
 * \param row Table Row structure containing data
 * \param err ObitErr for reporting errors.
 * \return return code, OBIT_IO_OK=> OK
 */
ObitIOCode 
ObitTablePTWriteRow  (ObitTablePT *in, olong iPTRow, ObitTablePTRow *row,
		      ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gshort    *siRow;
  odouble   *dRow;
  oint      *iRow, i;
  ofloat    *fRow;
  gchar     *cRow;
  gboolean  *lRow;
  guint8    *bRow;
  gchar *routine = "ObitTablePTWriteRow";
  

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA(in, &myClassInfo));

  if (in->myStatus == OBIT_Inactive) {
    Obit_log_error(err, OBIT_Error,
		   "AIPS PT Table is inactive for %s ", in->name);
    return retCode;
 }

  /* Typed pointers to row of data */  
  dRow  = (odouble*)in->buffer;
  siRow = (gshort*)in->buffer;
  iRow  = (oint*)in->buffer;
  fRow  = (ofloat*)in->buffer;
  cRow  = (gchar*)in->buffer;
  lRow  = (gboolean*)in->buffer;
  bRow  = (guint8*)in->buffer;
  
  /* Make full copy of all data */
  dRow[in->TimeOff] = row->Time;
  fRow[in->TimeIOff] = row->TimeI;
  iRow[in->antNoOff] = row->antNo;
  lRow[in->pointingTrackingOff] = row->pointingTracking;
  lRow[in->usePolynomialsOff] = row->usePolynomials;
  dRow[in->timeOriginOff] = row->timeOrigin;
  iRow[in->pointingModelIdOff] = row->pointingModelId;
  lRow[in->overTheTopOff] = row->overTheTop;
  iRow[in->SourceReferenceCodeOffsetOff] = row->SourceReferenceCodeOffset;
  dRow[in->sourceEquinoxOffsetOff] = row->sourceEquinoxOffset;
  if (in->EncoderCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->EncoderCol]; i++) 
      fRow[in->EncoderOff+i] = row->Encoder[i];
  } 
  if (in->PointingDirectionCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->PointingDirectionCol]; i++) 
      dRow[in->PointingDirectionOff+i] = row->PointingDirection[i];
  } 
  if (in->targetCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->targetCol]; i++) 
      dRow[in->targetOff+i] = row->target[i];
  } 
  if (in->offsetCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->offsetCol]; i++) 
      dRow[in->offsetOff+i] = row->offset[i];
  } 
  if (in->SourceOffsetCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->SourceOffsetCol]; i++) 
      dRow[in->SourceOffsetOff+i] = row->SourceOffset[i];
  } 
  if (in->sampledTimeIntervalCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->sampledTimeIntervalCol]; i++) 
      dRow[in->sampledTimeIntervalOff+i] = row->sampledTimeInterval[i];
  } 
  if (in->AtmosphericCorrectionCol >= 0) { 
    for (i=0; i<in->myDesc->repeat[in->AtmosphericCorrectionCol]; i++) 
      fRow[in->AtmosphericCorrectionOff+i] = row->AtmosphericCorrection[i];
  } 

  /* copy status */
  iRow[in->myDesc->statusOff] = row->status;
   
  /* Write one row */
  in->myDesc->numRowBuff = 1;
 
  /* Write row iPTRow */
  retCode = ObitTableWrite ((ObitTable*)in, iPTRow, NULL,  err);
  if (err->error) 
    Obit_traceback_val (err, routine,in->name, retCode);

  return retCode;
} /*  end ObitTablePTWriteRow */

/**
 * Shutdown I/O.
 * \param in Pointer to object to be closed.
 * \param err ObitErr for reporting errors.
 * \return error code, OBIT_IO_OK=> OK
 */
ObitIOCode ObitTablePTClose (ObitTablePT *in, ObitErr *err)
{
  ObitIOCode retCode = OBIT_IO_SpecErr;
  gchar *routine = "ObitTablePTClose";

  /* error checks */
  g_assert (ObitErrIsA(err));
  if (err->error) return retCode;
  g_assert (ObitIsA((Obit*)in, &myClassInfo));
  /* Something going on? */
  if (in->myStatus == OBIT_Inactive) return OBIT_IO_OK;

  /* Update keywords on descriptor if not ReadOnly*/
  if (in->myDesc->access != OBIT_IO_ReadOnly) 
    ObitTablePTDumpKey (in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  /* Close */
  retCode = ObitTableClose ((ObitTable*)in, err);
  if (err->error) 
    Obit_traceback_val (err, routine, in->name, retCode);

  return retCode;
} /* end ObitTablePTClose */

/*---------------Private functions--------------------------*/
/*----------------  TablePT Row  ----------------------*/
/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTablePTRowInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePTRow *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */
  /* Set array members to NULL */
  in->Encoder = NULL;
  in->PointingDirection = NULL;
  in->target = NULL;
  in->offset = NULL;
  in->SourceOffset = NULL;
  in->sampledTimeInterval = NULL;
  in->AtmosphericCorrection = NULL;

} /* end ObitTablePTRowInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTablePTRow* cast to an Obit*.
 */
void ObitTablePTRowClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePTRow *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myRowClassInfo));

  /* delete this class members */
  /* Do not free data array pointers as they were not malloced */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myRowClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTablePTRowClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTablePTRowClassInit (void)
{
  if (myRowClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myRowClassInfo.ClassName   = g_strdup(myRowClassName);
  myRowClassInfo.ParentClass = ObitParentGetRowClass();

  /* Set function pointers */
  ObitTablePTRowClassInfoDefFn ((gpointer)&myRowClassInfo);
 
  myRowClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTablePTRowClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTablePTRowClassInfoDefFn (gpointer inClass)
{
  ObitTablePTRowClassInfo *theClass = (ObitTablePTRowClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myRowClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myRowClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTablePTRowClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTablePTRowClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTablePTRowGetClass;
  theClass->newObit         = NULL;
  theClass->newObitTableRow = (newObitTableRowFP)newObitTablePTRow;
  theClass->ObitCopy        = NULL;
  theClass->ObitClone       = NULL;
  theClass->ObitClear       = (ObitClearFP)ObitTablePTRowClear;
  theClass->ObitInit        = (ObitInitFP)ObitTablePTRowInit;

} /* end ObitTablePTRowClassDefFn */

/*------------------  TablePT  ------------------------*/

/**
 * Creates empty member objects, initialize reference count.
 * Parent classes portions are (recursively) initialized first
 * \param inn Pointer to the object to initialize.
 */
void ObitTablePTInit  (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePT *in = inn;

  /* error checks */
  g_assert (in != NULL);

  /* recursively initialize parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  if ((ParentClass!=NULL) && ( ParentClass->ObitInit!=NULL)) 
    ParentClass->ObitInit (inn);

  /* set members in this class */

} /* end ObitTablePTInit */

/**
 * Deallocates member objects.
 * Does (recursive) deallocation of parent class members.
 * For some reason this wasn't build into the GType class.
 * \param  inn Pointer to the object to deallocate.
 *           Actually it should be an ObitTablePT* cast to an Obit*.
 */
void ObitTablePTClear (gpointer inn)
{
  ObitClassInfo *ParentClass;
  ObitTablePT *in = inn;

  /* error checks */
  g_assert (ObitIsA(in, &myClassInfo));

  /* delete this class members */
  
  /* unlink parent class members */
  ParentClass = (ObitClassInfo*)(myClassInfo.ParentClass);
  /* delete parent class members */
  if ((ParentClass!=NULL) && ( ParentClass->ObitClear!=NULL)) 
    ParentClass->ObitClear (inn);
  
} /* end ObitTablePTClear */

/**
 * Initialize global ClassInfo Structure.
 */
void ObitTablePTClassInit (void)
{
  if (myClassInfo.initialized) return;  /* only once */
  
  /* Set name and parent for this class */
  myClassInfo.ClassName   = g_strdup(myClassName);
  myClassInfo.ParentClass = ObitParentGetClass();

  /* Set function pointers */
  ObitTablePTClassInfoDefFn ((gpointer)&myClassInfo);
 
  myClassInfo.initialized = TRUE; /* Now initialized */
 
} /* end ObitTablePTClassInit */

/**
 * Initialize global ClassInfo Function pointers.
 */
static void ObitTablePTClassInfoDefFn (gpointer inClass)
{
  ObitTablePTClassInfo *theClass = (ObitTablePTClassInfo*)inClass;
  ObitClassInfo *ParentClass = (ObitClassInfo*)myClassInfo.ParentClass;

  if (theClass->initialized) return;  /* only once */

  /* Check type of inClass */
  g_assert (ObitInfoIsA(inClass, (ObitClassInfo*)&myClassInfo));

  /* Initialize (recursively) parent class first */
  if ((ParentClass!=NULL) && 
      (ParentClass->ObitClassInfoDefFn!=NULL))
    ParentClass->ObitClassInfoDefFn(theClass);

  /* function pointers defined or overloaded this class */
  theClass->ObitClassInit = (ObitClassInitFP)ObitTablePTClassInit;
  theClass->ObitClassInfoDefFn = (ObitClassInfoDefFnFP)ObitTablePTClassInfoDefFn;
  theClass->ObitGetClass  = (ObitGetClassFP)ObitTablePTGetClass;
  theClass->newObit       = (newObitFP)newObitTablePT;
  theClass->ObitCopy      = (ObitCopyFP)ObitTablePTCopy;
  theClass->ObitClone     = (ObitCloneFP)ObitTableClone;
  theClass->ObitClear     = (ObitClearFP)ObitTablePTClear;
  theClass->ObitInit      = (ObitInitFP)ObitTablePTInit;
  theClass->ObitTableConvert = (ObitTableConvertFP)ObitTablePTConvert;
  theClass->ObitTableOpen    = (ObitTableOpenFP)ObitTablePTOpen;
  theClass->ObitTableClose   = (ObitTableCloseFP)ObitTablePTClose;
  theClass->ObitTableRead    = (ObitTableReadFP)ObitTableRead;
  theClass->ObitTableReadSelect = 
    (ObitTableReadSelectFP)ObitTableReadSelect;
  theClass->ObitTableWrite = (ObitTableWriteFP)ObitTableWrite;
  theClass->ObitTableReadRow = 
    (ObitTableReadRowFP)ObitTablePTReadRow;
  theClass->ObitTableWriteRow = 
    (ObitTableWriteRowFP)ObitTablePTWriteRow;

} /* end ObitTablePTClassDefFn */

/**
 * Get table specific information from the infolist or descriptor
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTablePTUpdate (ObitTablePT *in, ObitErr *err)
{
  olong i;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM];
  ObitTableDesc *desc;
   

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Get Keywords */
   /* revision */
  in->revision = 1; 
  ObitInfoListGetTest(in->myDesc->info, "TABREV", &type, dim, 
		       (gpointer)&in->revision);
   /* numTerm */
  in->numTerm = 0; 
  ObitInfoListGetTest(in->myDesc->info, "NO_TERM", &type, dim, 
		       (gpointer)&in->numTerm);
   /* RefDate */
  strncpy (in->RefDate, "YYYYMMDD", MAXKEYCHARTABLEPT); 
  ObitInfoListGetTest(in->myDesc->info, "RDATE", &type, dim, 
		       (gpointer)&in->RefDate);

  /* initialize column numbers/offsets */
  in->TimeOff = -1;
  in->TimeCol = -1;
  in->TimeIOff = -1;
  in->TimeICol = -1;
  in->antNoOff = -1;
  in->antNoCol = -1;
  in->EncoderOff = -1;
  in->EncoderCol = -1;
  in->pointingTrackingOff = -1;
  in->pointingTrackingCol = -1;
  in->usePolynomialsOff = -1;
  in->usePolynomialsCol = -1;
  in->timeOriginOff = -1;
  in->timeOriginCol = -1;
  in->PointingDirectionOff = -1;
  in->PointingDirectionCol = -1;
  in->targetOff = -1;
  in->targetCol = -1;
  in->offsetOff = -1;
  in->offsetCol = -1;
  in->pointingModelIdOff = -1;
  in->pointingModelIdCol = -1;
  in->overTheTopOff = -1;
  in->overTheTopCol = -1;
  in->SourceOffsetOff = -1;
  in->SourceOffsetCol = -1;
  in->SourceReferenceCodeOffsetOff = -1;
  in->SourceReferenceCodeOffsetCol = -1;
  in->sourceEquinoxOffsetOff = -1;
  in->sourceEquinoxOffsetCol = -1;
  in->sampledTimeIntervalOff = -1;
  in->sampledTimeIntervalCol = -1;
  in->AtmosphericCorrectionOff = -1;
  in->AtmosphericCorrectionCol = -1;
  /* Find columns and set offsets */
  desc = in->myDesc;
  if (desc->FieldName) {
    for (i=0; i<desc->nfield; i++) {
      if (!strncmp (desc->FieldName[i], "TIME    ", 8)) {
	 in->TimeOff = desc->offset[i];
 	 in->TimeCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIME INTERVAL", 13)) {
	 in->TimeIOff = desc->offset[i];
 	 in->TimeICol = i;
      }
      if (!strncmp (desc->FieldName[i], "ANTENNA NO.", 11)) {
	 in->antNoOff = desc->offset[i];
 	 in->antNoCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ENCODER", 7)) {
	 in->EncoderOff = desc->offset[i];
 	 in->EncoderCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POINTINGTRACKING", 16)) {
	 in->pointingTrackingOff = desc->offset[i];
 	 in->pointingTrackingCol = i;
      }
      if (!strncmp (desc->FieldName[i], "USEPOLYNOMIALS", 14)) {
	 in->usePolynomialsOff = desc->offset[i];
 	 in->usePolynomialsCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TIMEORIGIN", 10)) {
	 in->timeOriginOff = desc->offset[i];
 	 in->timeOriginCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POINTINGDIRECTION", 17)) {
	 in->PointingDirectionOff = desc->offset[i];
 	 in->PointingDirectionCol = i;
      }
      if (!strncmp (desc->FieldName[i], "TARGET", 6)) {
	 in->targetOff = desc->offset[i];
 	 in->targetCol = i;
      }
      if (!strncmp (desc->FieldName[i], "OFFSET", 6)) {
	 in->offsetOff = desc->offset[i];
 	 in->offsetCol = i;
      }
      if (!strncmp (desc->FieldName[i], "POINTINGMODELID", 15)) {
	 in->pointingModelIdOff = desc->offset[i];
 	 in->pointingModelIdCol = i;
      }
      if (!strncmp (desc->FieldName[i], "OVERTHETOP", 10)) {
	 in->overTheTopOff = desc->offset[i];
 	 in->overTheTopCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCEOFFSET", 12)) {
	 in->SourceOffsetOff = desc->offset[i];
 	 in->SourceOffsetCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCEREFERENCECODEOFF", 22)) {
	 in->SourceReferenceCodeOffsetOff = desc->offset[i];
 	 in->SourceReferenceCodeOffsetCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SOURCEEQUINOXOFFSET", 19)) {
	 in->sourceEquinoxOffsetOff = desc->offset[i];
 	 in->sourceEquinoxOffsetCol = i;
      }
      if (!strncmp (desc->FieldName[i], "SAMPLEDTIMEINTERVAL", 19)) {
	 in->sampledTimeIntervalOff = desc->offset[i];
 	 in->sampledTimeIntervalCol = i;
      }
      if (!strncmp (desc->FieldName[i], "ATMOSPHERICCORRECTION", 21)) {
	 in->AtmosphericCorrectionOff = desc->offset[i];
 	 in->AtmosphericCorrectionCol = i;
      }
     }
  }

  /* Check required columns */
  Obit_return_if_fail((in->TimeOff > -1), err,
       "ObitTablePTUpdate: Could not find column Time");
  Obit_return_if_fail((in->TimeIOff > -1), err,
       "ObitTablePTUpdate: Could not find column TimeI");
  Obit_return_if_fail((in->antNoOff > -1), err,
       "ObitTablePTUpdate: Could not find column antNo");
  Obit_return_if_fail((in->EncoderOff > -1), err,
       "ObitTablePTUpdate: Could not find column Encoder");
  Obit_return_if_fail((in->pointingTrackingOff > -1), err,
       "ObitTablePTUpdate: Could not find column pointingTracking");
  Obit_return_if_fail((in->usePolynomialsOff > -1), err,
       "ObitTablePTUpdate: Could not find column usePolynomials");
  Obit_return_if_fail((in->timeOriginOff > -1), err,
       "ObitTablePTUpdate: Could not find column timeOrigin");
  Obit_return_if_fail((in->PointingDirectionOff > -1), err,
       "ObitTablePTUpdate: Could not find column PointingDirection");
  Obit_return_if_fail((in->targetOff > -1), err,
       "ObitTablePTUpdate: Could not find column target");
  Obit_return_if_fail((in->offsetOff > -1), err,
       "ObitTablePTUpdate: Could not find column offset");
  Obit_return_if_fail((in->pointingModelIdOff > -1), err,
       "ObitTablePTUpdate: Could not find column pointingModelId");
} /* end ObitTablePTUpdate */

/**
 * Copy table specific (keyword) information  to infolist.
 * \param info Table to update
 * \param err  ObitErr for reporting errors.
 */
static void ObitTablePTDumpKey (ObitTablePT *in, ObitErr *err)
{
  ObitInfoList *info=NULL;
  ObitInfoType type;
  gint32 dim[MAXINFOELEMDIM] = {1,1,1,1,1};

 /* error checks */
   g_assert(ObitErrIsA(err));
  if (err->error) return;
  g_assert (ObitIsA(in, &myClassInfo));

  /* Set Keywords */
  /*if (in->myIO!=NULL) info = ((ObitTableDesc*)(in->myIO->myDesc))->info;
    else info = in->myDesc->info;*/
  info = in->myDesc->info;
  /* revision */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "TABREV", type, dim, 
		  (gpointer)&in->revision);
  /* numTerm */
  type  = OBIT_oint;
  dim[0] = 1;
  ObitInfoListAlwaysPut(info, "NO_TERM", type, dim, 
		  (gpointer)&in->numTerm);
  /* RefDate */
  type  = OBIT_string;
  dim[0] = MAXKEYCHARTABLEPT;
  ObitInfoListAlwaysPut(info, "RDATE", type, dim, 
		  (gpointer)&in->RefDate);
   
} /* end ObitTablePTDumpKey */
